=== modified file 'MANIFEST.in'
--- MANIFEST.in	2007-03-26 06:08:50 +0000
+++ MANIFEST.in	2006-12-24 06:43:14 +0000
@@ -1,4 +1,4 @@
-include dev.cfg loggerhead.conf.example README.txt NEWS
+include dev.cfg loggerhead.conf
 recursive-include loggerhead/templates *.kid
 recursive-include loggerhead/config *.cfg
 recursive-include loggerhead/static *

=== modified file 'NEWS'
--- NEWS	2007-05-21 06:19:12 +0000
+++ NEWS	2007-01-24 19:29:58 +0000
@@ -2,7 +2,7 @@
 What's changed in loggerhead?
 =============================
 
-1.1.1  [24jan2007]
+1.1.1  [24jan2006]
 ------------------
 
     - fix broken inventory page (oops!)
@@ -10,7 +10,7 @@
     - fix a few rendering problems with kid and safari
 
 
-1.1  [20jan2007]
+1.1  [20jan2006]
 ----------------
 
     - new feature to compare two revisions to each other
@@ -46,4 +46,3 @@
 ----------------
 
     - initial release
-

=== removed file 'homepage/download/loggerhead-1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1-0.13.tar.gz and homepage/download/loggerhead-1.1-0.13.tar.gz differ
=== removed file 'homepage/download/loggerhead-1.1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1.1-0.13.tar.gz and homepage/download/loggerhead-1.1.1-0.13.tar.gz differ
=== modified file 'homepage/index.html'
--- homepage/index.html	2007-01-24 23:39:39 +0000
+++ homepage/index.html	2007-01-24 18:45:06 +0000
@@ -25,27 +25,13 @@
     in python 2.4.
     </p>
     
-    <h2> News </h2>
-    
-    <ul>
-    <li> <span class="date"> 24 Jan 2007 </span> <br>
-        Loggerhead 1.1.1 released, to fix a paper-bag bug and a couple of
-        rendering quirks. </li>
-    <li> <span class="date"> 20 Jan 2007 </span> <br>
-        Loggerhead 1.1 released, with a lot of new features and improvements.
-        </li>
-    </ul>
-    
     <h2> Download </h2>
     
     <p>
-    The current version is 1.1.1-0.13 (meaning 1.1.1, requiring bazaar 0.13),
-    released on 24 Jan 2006 at revision 109.
+    The current version is 1.1-0.13 (meaning 1.1, based on bazaar 0.13),
+    released on 20 Jan 2006 at revision 98.
     </p>
     <ul class="downloads">
-    <li> <a href="download/loggerhead-1.1.1-0.13.tar.gz"> loggerhead-1.1.1-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 288af4396620443b7f2acd96a62ffbbf </span>
-        </li>
     <li> <a href="download/loggerhead-1.1-0.13.tar.gz"> loggerhead-1.1-0.13.tar.gz </a>
         <br /> <span class="md5"> MD5: 26194d00c72dbcaf63d14d9d099ee91e </span>
         </li>

=== modified file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	2007-01-24 23:39:39 +0000
+++ homepage/loggerhead.css	2006-12-24 06:54:21 +0000
@@ -42,9 +42,3 @@
 .link {
 	margin-left: 1em;
 }
-
-.date {
-    font-weight: bold;
-    font-size: smaller;
-    text-decoration: underline;
-}

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2007-06-18 23:07:53 +0000
+++ loggerhead.conf.example	2007-01-14 05:40:40 +0000
@@ -12,9 +12,6 @@
 # if you want a special title on the front page, set it here:
 title = 'branches in loggerhead'
 
-# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
-log.roll = 'weekly'
-
 # group branches by project:
 [bazaar]
 

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2007-05-21 06:19:31 +0000
+++ loggerhead/TODO	2007-01-21 02:46:53 +0000
@@ -6,15 +6,11 @@
 
 * potentially do a 'bzr pull' on a branch on an interval timer
 
+* maybe change "changes" to "history"?  -- asked on bazaar-dev@ for opinions.
+    -- nobody seems to care.
+
 * browse view: sort by name, last change?
 
 * something is leaking on www.lag.net/branches
 
 * download tar archive of revision?
-
-* nicholas allen suggested the ability to change the # of context lines
-  in diffs (probably something inside bzrlib) and also the ability to see
-  an entire file in diff format
-
-* setup.py install doesn't work
-

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2007-07-04 14:51:40 +0000
+++ loggerhead/__init__.py	2006-12-11 06:44:19 +0000
@@ -1,1 +0,0 @@
-import turbozpt

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2007-03-06 04:27:05 +0000
+++ loggerhead/branchview.py	2007-01-16 03:52:29 +0000
@@ -23,7 +23,6 @@
 import logging
 import posixpath
 import threading
-import urllib
 
 import turbogears
 from cherrypy import HTTPRedirect
@@ -161,7 +160,6 @@
             elements = [elements]
         if elements[0].startswith('/'):
             elements[0] = elements[0][1:]
-        elements = [urllib.quote(x) for x in elements]
         return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
 
     def last_updated(self):

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-06-25 01:40:37 +0000
+++ loggerhead/changecache.py	2007-01-08 00:00:26 +0000
@@ -48,7 +48,9 @@
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
+        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
         self._changes_filename = os.path.join(cache_path, 'changes')
+        self._changes_diffs_filename = os.path.join(cache_path, 'changes-diffs')
         
         # use a lockfile since the cache folder could be shared across different processes.
         self._lock = LockFile(os.path.join(cache_path, 'lock'))
@@ -56,7 +58,8 @@
         
         # this is fluff; don't slow down startup time with it.
         def log_sizes():
-            self.log.info('Using change cache %s; %d entries.' % (cache_path, self.size()))
+            s1, s2 = self.sizes()
+            self.log.info('Using change cache %s; %d/%d entries.' % (cache_path, s1, s2))
         threading.Thread(target=log_sizes).start()
     
     @with_lock
@@ -73,56 +76,64 @@
         pass
     
     @with_lock
-    def get_changes(self, revid_list):
+    def get_changes(self, revid_list, get_diffs=False):
         """
         get a list of changes by their revision_ids.  any changes missing
         from the cache are fetched by calling L{History.get_change_uncached}
         and inserted into the cache before returning.
         """
-        cache = shelve.open(self._changes_filename, 'c', protocol=2)
-
-        try:
-            out = []
-            fetch_list = []
-            sfetch_list = []
-            for revid in revid_list:
-                # if the revid is in unicode, use the utf-8 encoding as the key
-                srevid = util.to_utf8(revid)
-
-                if srevid in cache:
-                    out.append(cache[srevid])
-                else:
-                    #self.log.debug('Entry cache miss: %r' % (revid,))
-                    out.append(None)
-                    fetch_list.append(revid)
-                    sfetch_list.append(srevid)
-
-            if len(fetch_list) > 0:
-                # some revisions weren't in the cache; fetch them
-                changes = self.history.get_changes_uncached(fetch_list)
-                if len(changes) == 0:
-                    return changes
-                for i in xrange(len(revid_list)):
-                    if out[i] is None:
-                        cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
-            return out
-        finally:
-            cache.close()
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
+
+        out = []
+        fetch_list = []
+        sfetch_list = []
+        for revid in revid_list:
+            # if the revid is in unicode, use the utf-8 encoding as the key
+            srevid = util.to_utf8(revid)
+            
+            if srevid in cache:
+                out.append(cache[srevid])
+            else:
+                #self.log.debug('Entry cache miss: %r' % (revid,))
+                out.append(None)
+                fetch_list.append(revid)
+                sfetch_list.append(srevid)
+        
+        if len(fetch_list) > 0:
+            # some revisions weren't in the cache; fetch them
+            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
+            if changes is None:
+                return changes
+            for i in xrange(len(revid_list)):
+                if out[i] is None:
+                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
+        
+        cache.close()
+        return out
     
     @with_lock
-    def full(self):
-        cache = shelve.open(self._changes_filename, 'c', protocol=2)
+    def full(self, get_diffs=False):
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
         try:
             return (len(cache) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in cache)
         finally:
             cache.close()
 
     @with_lock
-    def size(self):
+    def sizes(self):
         cache = shelve.open(self._changes_filename, 'c', protocol=2)
         s1 = len(cache)
         cache.close()
-        return s1
+        cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        s2 = len(cache)
+        cache.close()
+        return s1, s2
         
     def check_rebuild(self, max_time=3600):
         """

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2007-06-19 00:27:53 +0000
+++ loggerhead/controllers/__init__.py	2007-01-14 05:40:40 +0000
@@ -25,7 +25,7 @@
 
 import turbogears
 from turbogears import controllers
-from cherrypy import NotFound
+from cherrypy import HTTPRedirect, NotFound
 from configobj import ConfigObj
 
 from loggerhead import util
@@ -52,38 +52,24 @@
         
         self._views = []
         for view_name in config.sections:
-            log.debug('Configuring (project %s) branch %s...', name, view_name)
+            log.debug('Configuring (project %r) branch %r...', name, view_name)
             self._add_view(view_name, config[view_name], config[view_name].get('folder'))
         
-        self._auto_folder = config.get('auto_publish_folder', None)
-        self._auto_list = []
-        if self._auto_folder is not None:
-            self._recheck_auto_folders()
+        auto_folder = config.get('auto_publish_folder', None)
+        if auto_folder is not None:
+            auto_list = []
+            # scan a folder for bazaar branches, and add them automatically
+            for path, folders, filenames in os.walk(auto_folder):
+                for folder in folders:
+                    folder = os.path.join(path, folder)
+                    if is_branch(folder):
+                        auto_list.append(folder)
+            auto_list.sort()
+            for folder in auto_list:
+                view_name = os.path.basename(folder)
+                log.debug('Auto-configuring (project %r) branch %r...', name, view_name)
+                self._add_view(view_name, ConfigObj(), folder)
     
-    def _recheck_auto_folders(self):
-        if self._auto_folder is None:
-            return
-        auto_list = []
-        # scan a folder for bazaar branches, and add them automatically
-        for path, folders, filenames in os.walk(self._auto_folder):
-            for folder in folders:
-                folder = os.path.join(path, folder)
-                if is_branch(folder):
-                    auto_list.append(folder)
-        auto_list.sort()
-        if auto_list == self._auto_list:
-            # nothing has changed; do nothing.
-            return
-
-        # rebuild views:
-        log.debug('Rescanning auto-folder for project %s ...', self.name)
-        self._views = []
-        for folder in auto_list:
-            view_name = os.path.basename(folder)
-            log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
-            self._add_view(view_name, ConfigObj(), folder)
-        self._auto_list = auto_list
-        
     def _add_view(self, view_name, view_config, folder):
         c_view_name = cherrypy_friendly(view_name)
         view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
@@ -94,23 +80,20 @@
 
 
 class Root (controllers.RootController):
-    def __init__(self, config):
+    def __init__(self):
         self._projects = []
-        self._config = config
-        for project_name in self._config.sections:
+        for project_name in sys._loggerhead_config.sections:
             c_project_name = cherrypy_friendly(project_name)
-            project = Project(c_project_name, self._config[project_name])
+            project = Project(c_project_name, sys._loggerhead_config[project_name])
             self._projects.append(project)
             setattr(self, c_project_name, project)
         
     @turbogears.expose(template='loggerhead.templates.browse')
     def index(self):
-        for p in self._projects:
-            p._recheck_auto_folders()
         return {
             'projects': self._projects,
             'util': util,
-            'title': self._config.get('title', ''),
+            'title': sys._loggerhead_config.get('title', ''),
         }
 
     def _check_rebuild(self):
@@ -119,6 +102,9 @@
                 v.check_rebuild()
 
 
+# singleton:
+Root = Root()
+
 
 # for use in profiling the very-slow get_change() method:
 #h = Root.bazaar.bzr_dev.get_history()

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2007-07-04 14:51:40 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-01-21 00:05:52 +0000
@@ -25,7 +25,7 @@
 import time
 
 import turbogears
-from cherrypy import HTTPError, InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -47,8 +47,7 @@
         self.log = branch.log
 
     @util.strip_whitespace
-    @turbogears.expose(html='zpt:loggerhead.templates.annotate')
-    #@turbogears.expose(html='loggerhead.templates.annotate')
+    @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
         z = time.time()
         h = self._branch.get_history()
@@ -57,26 +56,23 @@
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
-            revid = h.last_revid
-
-        path = None
-        if len(args) > 1:
-            path = '/'.join(args[1:])
-            if not path.startswith('/'):
-                path = '/' + path
+            revid = None
         
         file_id = kw.get('file_id', None)
-        if (file_id is None) and (path is None):
-            raise HTTPError(400, 'No file_id or filename provided to annotate')
-
         if file_id is None:
-            file_id = h.get_file_id(revid, path)
+            raise HTTPRedirect(self._branch.url('/changes'))
+
+        try:
+            revid_list, revid = h.get_file_view(revid, file_id)
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
             
         # no navbar for revisions
         navigation = util.Container()
         
-        if path is None:
-            path = h.get_path(revid, file_id)
+        path = h.get_path(revid, file_id)
         filename = os.path.basename(path)
 
         vals = {

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2007-06-27 17:06:57 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-20 21:17:53 +0000
@@ -35,14 +35,16 @@
         h = self._branch.get_history()
         pagesize = int(self._branch.config.get('pagesize', '20'))
 
-        revid_list = h.get_file_view(h.last_revid, None)
+        revid_list, start_revid = h.get_file_view(None, None)
         entries = list(h.get_changes(list(revid_list)[:pagesize]))
 
         vals = {
+            'external_url': cherrypy.request.base,
             'branch': self._branch,
             'changes': entries,
             'util': util,
             'history': h,
+            'scan_url': '/changes',
             'updated': entries[0].date.isoformat() + 'Z',
         }
         h.flush_cache()

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2007-06-26 04:32:43 +0000
+++ loggerhead/controllers/bundle_ui.py	2007-01-21 00:05:52 +0000
@@ -20,7 +20,7 @@
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, InternalError, response
+from cherrypy import HTTPRedirect, response
 
 from loggerhead import util
 
@@ -34,23 +34,24 @@
 
     @turbogears.expose()
     def default(self, *args, **kw):
-        # /bundle/<rev_id>/[<compare_rev_id>/]filename
+        # /bundle/<rev_id>/filename
         z = time.time()
         h = self._branch.get_history()
+        compare_revid = kw.get('compare_revid', None)
 
         if len(args) < 1:
             raise HTTPRedirect(self._branch.url('/changes'))
         revid = h.fix_revid(args[0])
+        compare_revid = None
         if len(args) >= 3:
             compare_revid = h.fix_revid(args[1])
-        else:
-            compare_revid = None
-        
+
         try:
             bundle_data = h.get_bundle(revid, compare_revid)
-        except:
-            self.log.exception('Exception fetching bundle')
-            raise InternalError('Could not fetch bundle')
+        except Exception, x:
+            self.log.error('Exception fetching bundle: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
             
         response.headers['Content-Type'] = 'text/plain'
         response.headers['Content-Length'] = len(bundle_data)

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-06-27 15:38:47 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-01-21 00:05:52 +0000
@@ -21,11 +21,13 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
 
+
+
 class ChangeLogUI (object):
     
     def __init__(self, branch):
@@ -36,7 +38,6 @@
     @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
-        print args
         z = time.time()
         h = self._branch.get_history()
         config = self._branch.config
@@ -64,42 +65,27 @@
             if len(revid_list) == 0:
                 scan_list = revid_list
             else:
-                if revid in revid_list: # XXX is this always true?
-                    i = revid_list.index(revid)
-                else:
-                    i = None
-                scan_list = revid_list[i:]
+                scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
             entry_list = scan_list[:pagesize]
             entries = h.get_changes(entry_list)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
                                     file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(navigation)
+        util.fill_in_navigation(h, navigation)
         
         entries = list(entries)
         # add parent & merge-point branch-nick info, in case it's useful
         h.get_branch_nicks(entries)
-        
-        # does every change on this page have the same committer?  if so,
-        # tell the template to show committer info in the "details block"
-        # instead of on each line.
-        all_same_author = True
-
-        if entries:
-            author = entries[0].author
-            for e in entries[1:]:
-                if e.author != author:
-                    all_same_author = False
-                    break
 
         vals = {
             'branch': self._branch,
-            'changes': entries,
+            'changes': list(entries),
             'util': util,
             'history': h,
             'revid': revid,
@@ -109,7 +95,6 @@
             'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
             'query': query,
             'search_failed': search_failed,
-            'all_same_author': all_same_author,
         }
         h.flush_cache()
         self.log.info('/changes %r: %r secs' % (revid, time.time() - z))

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2007-05-23 17:42:19 +0000
+++ loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
@@ -60,6 +60,5 @@
         self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
         response.headers['Content-Type'] = mime_type
         response.headers['Content-Length'] = len(content)
-        response.headers['Content-Disposition'] = 'attachment; filename=%s'%(filename,)
         response.body = content
         return response.body

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2007-06-27 16:52:56 +0000
+++ loggerhead/controllers/inventory_ui.py	2007-01-21 00:05:52 +0000
@@ -25,7 +25,7 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -56,24 +56,19 @@
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
-            revid = h.last_revid
+            revid = None
         
-        try:
-            rev = h.get_revision(revid)
-            inv = h.get_inventory(revid)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
-
-        file_id = kw.get('file_id', inv.root.file_id)
+        file_id = kw.get('file_id', None)
         sort_type = kw.get('sort', None)
 
         try:
+            revid_list, revid = h.get_file_view(revid, file_id)
             rev = h.get_revision(revid)
             inv = h.get_inventory(revid)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         # no navbar for revisions
         navigation = util.Container()
@@ -104,7 +99,7 @@
             'path': path,
             'updir': updir,
             'updir_file_id': updir_file_id,
-            'filelist': h.get_filelist(inv, file_id, sort_type),
+            'filelist': h.get_filelist(inv, path, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2007-06-12 15:57:50 +0000
+++ loggerhead/controllers/revision_ui.py	2007-01-21 00:05:52 +0000
@@ -24,7 +24,7 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -35,8 +35,7 @@
         # BranchView object
         self._branch = branch
         self.log = branch.log
-    
-#    @util.lsprof
+        
     @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
@@ -57,15 +56,16 @@
         
         try:
             revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
         
         navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
                                     pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(navigation)
+        util.fill_in_navigation(h, navigation)
 
         if compare_revid is not None:
             change = h.get_diff(compare_revid, revid)

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2007-06-18 23:07:53 +0000
+++ loggerhead/daemon.py	2007-01-14 05:40:40 +0000
@@ -60,18 +60,3 @@
     f.write('%d\n' % (os.getpid(),))
     f.write('%s\n' % (home,))
     f.close()
-
-
-def is_running(pidfile):
-    try:
-        f = open(pidfile, 'r')
-    except IOError:
-        return False
-    pid = int(f.readline())
-    f.close()
-    try:
-        os.kill(pid, 0)
-    except OSError:
-        # no such process
-        return False
-    return True

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-06-27 17:06:57 +0000
+++ loggerhead/history.py	2007-01-24 19:26:27 +0000
@@ -147,27 +147,15 @@
     if len(message) == 1:
         # robey-style 1-line long message
         message = textwrap.wrap(message[0])
-    elif len(message) == 0:
-        # sometimes a commit may have NO message!
-        message = ['']
         
     # make short form of commit message
     short_message = message[0]
-    if len(short_message) > 80:
-        short_message = short_message[:80] + '...'
+    if len(short_message) > 60:
+        short_message = short_message[:60] + '...'
     
     return message, short_message
 
 
-def rich_filename(path, kind):
-    if kind == 'directory':
-        path += '/'
-    if kind == 'symlink':
-        path += '@'
-    return path
-        
-
-
 # from bzrlib
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
@@ -198,11 +186,9 @@
         z = time.time()
         self = cls()
         self._branch = branch
-        self._last_revid = self._branch.last_revision()
-        if self._last_revid is not None:
-            self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
-        else:
-            self._revision_graph = {}
+        self._history = branch.revision_history()
+        self._last_revid = self._history[-1]
+        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
         
         if name is None:
             name = self._branch.nick
@@ -213,11 +199,14 @@
         self._revision_info = {}
         self._revno_revid = {}
         self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
+        count = 0
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
             self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
+            count += 1
+        self._count = count
 
         # cache merge info
         self._where_merged = {}
@@ -237,11 +226,9 @@
 
     @with_branch_lock
     def out_of_date(self):
-        # the branch may have been upgraded on disk, in which case we're stale.
-        if self._branch.__class__ is not \
-               bzrlib.branch.Branch.open(self._branch.base).__class__:
+        if self._branch.revision_history()[-1] != self._last_revid:
             return True
-        return self._branch.last_revision() != self._last_revid
+        return False
 
     def use_cache(self, cache):
         self._change_cache = cache
@@ -276,6 +263,8 @@
     
     last_revid = property(lambda self: self._last_revid, None, None)
     
+    count = property(lambda self: self._count, None, None)
+
     @with_branch_lock
     def get_config(self):
         return self._branch.get_config()
@@ -291,9 +280,24 @@
         seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
         return revno_str
 
+    def get_sequence(self, revid):
+        seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
+        return seq
+    
     def get_revision_history(self):
         return self._full_history
     
+    def get_revid_sequence(self, revid_list, revid):
+        """
+        given a list of revision ids, return the sequence # of this revid in
+        the list.
+        """
+        seq = 0
+        for r in revid_list:
+            if revid == r:
+                return seq
+            seq += 1
+    
     def get_revids_from(self, revid_list, revid):
         """
         given a list of revision ids, yield revisions in graph order,
@@ -417,8 +421,6 @@
         # if a "revid" is actually a dotted revno, convert it to a revid
         if revid is None:
             return revid
-        if revid == 'head:':
-            return self._last_revid
         if self.revno_re.match(revid):
             revid = self._revno_revid[revid]
         return revid
@@ -426,22 +428,25 @@
     @with_branch_lock
     def get_file_view(self, revid, file_id):
         """
-        Given a revid and optional path, return a (revlist, revid) for
-        navigation through the current scope: from the revid (or the latest
-        revision) back to the original revision.
+        Given an optional revid and optional path, return a (revlist, revid)
+        for navigation through the current scope: from the revid (or the
+        latest revision) back to the original revision.
         
         If file_id is None, the entire revision history is the list scope.
+        If revid is None, the latest revision is used.
         """
         if revid is None:
             revid = self._last_revid
         if file_id is not None:
-            # since revid is 'start_revid', possibly should start the path
-            # tracing from revid... FIXME
+            # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
+            inv = self._branch.repository.get_revision_inventory(revid)
             revlist = list(self.get_short_revision_history_by_fileid(file_id))
             revlist = list(self.get_revids_from(revlist, revid))
         else:
             revlist = list(self.get_revids_from(None, revid))
-        return revlist
+        if revid is None:
+            revid = revlist[0]
+        return revlist, revid
     
     @with_branch_lock
     def get_view(self, revid, start_revid, file_id, query=None):
@@ -466,23 +471,19 @@
         file_id and query are never changed so aren't returned, but they may
         contain vital context for future url navigation.
         """
-        if start_revid is None:
-            start_revid = self._last_revid
-
         if query is None:
-            revid_list = self.get_file_view(start_revid, file_id)
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
             if revid is None:
                 revid = start_revid
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
-                revid_list= self.get_file_view(revid, file_id)
-                start_revid = revid
+                revid_list, start_revid = self.get_file_view(revid, file_id)
             return revid, start_revid, revid_list
         
         # potentially limit the search
-        if file_id is not None:
-            revid_list = self.get_file_view(start_revid, file_id)
+        if (start_revid is not None) or (file_id is not None):
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
         else:
             revid_list = None
 
@@ -508,23 +509,22 @@
             path = '/' + path
         return path
     
-    @with_branch_lock
-    def get_file_id(self, revid, path):
-        if (len(path) > 0) and not path.startswith('/'):
-            path = '/' + path
-        return self._branch.repository.get_revision_inventory(revid).path2id(path)
+    def get_where_merged(self, revid):
+        try:
+            return self._where_merged[revid]
+        except:
+            return []
     
-
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
         """
-        if '.' not in self.get_revno(revid):
+        if revid in self._history:
             return []
         
         merge_point = []
         while True:
-            children = self._where_merged.get(revid, [])
+            children = self.get_where_merged(revid)
             nexts = []
             for child in children:
                 child_parents = self._revision_graph[child]
@@ -576,45 +576,27 @@
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
         for change in changes:
-            # arch-converted branches may not have merged branch info :(
             for p in change.parents:
-                if p.revid in p_change_dict:
-                    p.branch_nick = p_change_dict[p.revid].branch_nick
-                else:
-                    p.branch_nick = '(missing)'
+                p.branch_nick = p_change_dict[p.revid].branch_nick
             for p in change.merge_points:
-                if p.revid in p_change_dict:
-                    p.branch_nick = p_change_dict[p.revid].branch_nick
-                else:
-                    p.branch_nick = '(missing)'
+                p.branch_nick = p_change_dict[p.revid].branch_nick
     
     @with_branch_lock
     def get_changes(self, revid_list, get_diffs=False):
         if self._change_cache is None:
-            changes = self.get_changes_uncached(revid_list)
+            changes = self.get_changes_uncached(revid_list, get_diffs)
         else:
-            changes = self._change_cache.get_changes(revid_list)
-        if len(changes) == 0:
+            changes = self._change_cache.get_changes(revid_list, get_diffs)
+        if changes is None:
             return changes
         
         # some data needs to be recalculated each time, because it may
         # change as new revisions are added.
-        for change in changes:
-            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
+        for i in xrange(len(revid_list)):
+            revid = revid_list[i]
+            change = changes[i]
+            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-            change.revno = self.get_revno(change.revid)
-            if get_diffs:
-                # this may be time-consuming, but it only happens on the revision page, and only for one revision at a time.
-                if len(change.parents) > 0:
-                    parent_revid = change.parents[0].revid
-                else:
-                    parent_revid = None
-                change.changes.modified = self._parse_diffs(parent_revid, change.revid)
-
-        parity = 0
-        for change in changes:
-            change.parity = parity
-            parity ^= 1
         
         return changes
 
@@ -661,10 +643,16 @@
         
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
 
+        if len(parents) == 0:
+            left_parent = None
+        else:
+            left_parent = revision.parent_ids[0]
+        
         message, short_message = clean_message(revision.message)
 
         entry = {
             'revid': revision.revision_id,
+            'revno': self.get_revno(revision.revision_id),
             'date': commit_time,
             'author': revision.committer,
             'branch_nick': revision.properties.get('branch-nick', None),
@@ -677,19 +665,11 @@
 
     @with_branch_lock
     @with_bzrlib_read_lock
-    def get_changes_uncached(self, revid_list):
-        done = False
-        while not done:
-            try:
-                rev_list = self._branch.repository.get_revisions(revid_list)
-                done = True
-            except (KeyError, bzrlib.errors.NoSuchRevision), e:
-                # this sometimes happens with arch-converted branches.
-                # i don't know why. :(
-                self.log.debug('No such revision (skipping): %s', e)
-                revid_list.remove(e.revision)
-        if not revid_list:
-            return []
+    def get_changes_uncached(self, revid_list, get_diffs=False):
+        try:
+            rev_list = self._branch.repository.get_revisions(revid_list)
+        except (KeyError, bzrlib.errors.NoSuchRevision):
+            return None
         
         delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
         combined_list = zip(rev_list, delta_list)
@@ -697,7 +677,7 @@
         entries = []
         for rev, (new_tree, old_tree, delta) in combined_list:
             entry = self.entry_from_revision(rev)
-            entry.changes = self.parse_delta(delta, old_tree, new_tree)
+            entry.changes = self.parse_delta(delta, get_diffs, old_tree, new_tree)
             entries.append(entry)
         
         return entries
@@ -726,11 +706,15 @@
             path = '/' + path
         return path, inv_entry.name, rev_tree.get_file_text(file_id)
     
-    def _parse_diffs(self, revid1, revid2):
+    @with_branch_lock
+    def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
         """
-        Return a list of processed diffs, in the format::
+        Return a nested data structure containing the changes in a delta::
         
-            list(
+            added: list((filename, file_id)),
+            renamed: list((old_filename, new_filename, file_id)),
+            deleted: list((filename, file_id)),
+            modified: list(
                 filename: str,
                 file_id: str,
                 chunks: list(
@@ -742,101 +726,79 @@
                     ),
                 ),
             )
-        """
-        old_tree, new_tree, delta = self._get_diff(revid1, revid2)
-        process = []
-        out = []
-        
-        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
-            if text_modified:
-                process.append((old_path, new_path, fid, kind))
-        for path, fid, kind, text_modified, meta_modified in delta.modified:
-            process.append((path, path, fid, kind))
-        
-        for old_path, new_path, fid, kind in process:
-            old_lines = old_tree.get_file_lines(fid)
-            new_lines = new_tree.get_file_lines(fid)
-            buffer = StringIO()
-            if old_lines != new_lines:
-                try:
-                    bzrlib.diff.internal_diff(old_path, old_lines,
-                                              new_path, new_lines, buffer)
-                except bzrlib.errors.BinaryFile:
-                    diff = ''
-                else:
-                    diff = buffer.getvalue()
-            else:
-                diff = ''
-            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff)))
-        
-        return out
-
-    def _process_diff(self, diff):
-        # doesn't really need to be a method; could be static.
-        chunks = []
-        chunk = None
-        for line in diff.splitlines():
-            if len(line) == 0:
-                continue
-            if line.startswith('+++ ') or line.startswith('--- '):
-                continue
-            if line.startswith('@@ '):
-                # new chunk
-                if chunk is not None:
-                    chunks.append(chunk)
-                chunk = util.Container()
-                chunk.diff = []
-                lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
-                old_lineno = lines[0]
-                new_lineno = lines[1]
-            elif line.startswith(' '):
-                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
-                                                 type='context', line=util.fixed_width(line[1:])))
-                old_lineno += 1
-                new_lineno += 1
-            elif line.startswith('+'):
-                chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
-                                                 type='insert', line=util.fixed_width(line[1:])))
-                new_lineno += 1
-            elif line.startswith('-'):
-                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
-                                                 type='delete', line=util.fixed_width(line[1:])))
-                old_lineno += 1
-            else:
-                chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
-                                                 type='unknown', line=util.fixed_width(repr(line))))
-        if chunk is not None:
-            chunks.append(chunk)
-        return chunks
-                
-    @with_branch_lock
-    def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
-        """
-        Return a nested data structure containing the changes in a delta::
-        
-            added: list((filename, file_id)),
-            renamed: list((old_filename, new_filename, file_id)),
-            deleted: list((filename, file_id)),
-            modified: list(
-                filename: str,
-                file_id: str,
-            )
+        
+        if C{get_diffs} is false, the C{chunks} will be omitted.
         """
         added = []
         modified = []
         renamed = []
         removed = []
         
+        def rich_filename(path, kind):
+            if kind == 'directory':
+                path += '/'
+            if kind == 'symlink':
+                path += '@'
+            return path
+        
+        def process_diff(diff):
+            chunks = []
+            chunk = None
+            for line in diff.splitlines():
+                if len(line) == 0:
+                    continue
+                if line.startswith('+++ ') or line.startswith('--- '):
+                    continue
+                if line.startswith('@@ '):
+                    # new chunk
+                    if chunk is not None:
+                        chunks.append(chunk)
+                    chunk = util.Container()
+                    chunk.diff = []
+                    lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
+                    old_lineno = lines[0]
+                    new_lineno = lines[1]
+                elif line.startswith(' '):
+                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
+                                                     type='context', line=util.html_clean(line[1:])))
+                    old_lineno += 1
+                    new_lineno += 1
+                elif line.startswith('+'):
+                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
+                                                     type='insert', line=util.html_clean(line[1:])))
+                    new_lineno += 1
+                elif line.startswith('-'):
+                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
+                                                     type='delete', line=util.html_clean(line[1:])))
+                    old_lineno += 1
+                else:
+                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
+                                                     type='unknown', line=util.html_clean(repr(line))))
+            if chunk is not None:
+                chunks.append(chunk)
+            return chunks
+                    
+        def handle_modify(old_path, new_path, fid, kind):
+            if not get_diffs:
+                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
+                return
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
+            buffer = StringIO()
+            bzrlib.diff.internal_diff(old_path, old_lines, new_path, new_lines, buffer)
+            diff = buffer.getvalue()
+            modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=process_diff(diff), raw_diff=diff))
+
         for path, fid, kind in delta.added:
             added.append((rich_filename(path, kind), fid))
         
         for path, fid, kind, text_modified, meta_modified in delta.modified:
-            modified.append(util.Container(filename=rich_filename(path, kind), file_id=fid))
+            handle_modify(path, path, fid, kind)
         
-        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
-            renamed.append((rich_filename(old_path, kind), rich_filename(new_path, kind), fid))
+        for oldpath, newpath, fid, kind, text_modified, meta_modified in delta.renamed:
+            renamed.append((rich_filename(oldpath, kind), rich_filename(newpath, kind), fid))
             if meta_modified or text_modified:
-                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
+                handle_modify(oldpath, newpath, fid, kind)
         
         for path, fid, kind in delta.removed:
             removed.append((rich_filename(path, kind), fid))
@@ -851,44 +813,48 @@
                 m.sbs_chunks = _make_side_by_side(m.chunks)
     
     @with_branch_lock
-    def get_filelist(self, inv, file_id, sort_type=None):
+    def get_filelist(self, inv, path, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
         """
-
-        dir_ie = inv[file_id]
-        path = inv.id2path(file_id)
+        while path.endswith('/'):
+            path = path[:-1]
+        if path.startswith('/'):
+            path = path[1:]
+        
+        entries = inv.entries()
+        
+        fetch_set = set()
+        for filepath, entry in entries:
+            fetch_set.add(entry.revision)
+        change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
+        
         file_list = []
-
-        for filename, entry in dir_ie.children.iteritems():
+        for filepath, entry in entries:
+            if posixpath.dirname(filepath) != path:
+                continue
+            filename = posixpath.basename(filepath)
+            rich_filename = filename
             pathname = filename
             if entry.kind == 'directory':
                 pathname += '/'
-
+            
+            # last change:
             revid = entry.revision
-            if self._change_cache:
-                timestamp = self.get_changes([revid])[0].date
-            else:
-                revision = self._branch.repository.get_revision(revid)
-                timestamp = datetime.datetime.fromtimestamp(revision.timestamp)
-
-            change = util.Container(date=timestamp,
-                                    revno=self.get_revno(revid))
-
-            file = util.Container(
-                filename=filename, executable=entry.executable, kind=entry.kind,
-                pathname=pathname, file_id=entry.file_id, size=entry.text_size,
-                revid=revid, change=change)
+            change = change_dict[revid]
+            
+            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
+                                  pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
             file_list.append(file)
-
-        if sort_type == 'filename' or sort_type is None:
+        
+        if sort_type == 'filename':
             file_list.sort(key=lambda x: x.filename)
         elif sort_type == 'size':
             file_list.sort(key=lambda x: x.size)
         elif sort_type == 'date':
             file_list.sort(key=lambda x: x.change.date)
-
+        
         parity = 0
         for file in file_list:
             file.parity = parity
@@ -897,7 +863,7 @@
         return file_list
 
 
-    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b\x0e-\x1f]')
+    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b-\x0c\x0e-\x1f]')
 
     @with_branch_lock
     def annotate_file(self, file_id, revid):
@@ -919,7 +885,7 @@
             if self._BADCHARS_RE.match(text):
                 # bail out; this isn't displayable text
                 yield util.Container(parity=0, lineno=1, status='same',
-                                     text='(This is a binary file.)',
+                                     text='<i>' + util.html_clean('(This is a binary file.)') + '</i>',
                                      change=util.Container())
                 return
         change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
@@ -937,9 +903,9 @@
                 trunc_revno = change.revno
                 if len(trunc_revno) > 10:
                     trunc_revno = trunc_revno[:9] + '...'
-
+                
             yield util.Container(parity=parity, lineno=lineno, status=status,
-                                 change=change, text=util.fixed_width(text))
+                                 change=change, text=util.html_clean(text))
             lineno += 1
         
         self.log.debug('annotate: %r secs' % (time.time() - z,))

=== removed file 'loggerhead/history2.py'
--- loggerhead/history2.py	2007-06-25 10:16:34 +0000
+++ loggerhead/history2.py	1970-01-01 00:00:00 +0000
@@ -1,194 +0,0 @@
-"""Extract data suitable for web presentation from Bazaar branches.
-
-The module is the interface between Loggerhead and bzrlib.  Other code in
-Loggerhead should not use bzrlib APIs, and functions and methods in this
-module should not return bzrlib data types.
-
-The core method is `History.getRevisionInfo`.  This method is meant to be
-cheap, so you should not worry about calling it multiple times with the same
-argument or calling it just to retreive a subset of the information it
-returns.
-
-Revisions are described using good old bzrlib revision ids.
-
-Revision ids, file ids, file names and file paths are always utf-8 encoded 8
-bit strings.
-"""
-
-class FileDelta(object):
-    """Information about how an inventory entry changed in a revision.
-
-    All attribute names are fairly self explanatory.  The ``*_parent`` fields
-    are the file id of the parent or ``None`` for the root.
-
-    :ivar file_id:
-    :ivar old_path:
-    :ivar new_path:
-    :ivar old_name:
-    :ivar new_name:
-    :ivar old_parent:
-    :ivar new_parent:
-    :ivar old_kind:
-    :ivar new_kind:
-    :ivar content_change:
-    :type content_change: ``bool``
-    :ivar execute_change: A boolean reflecting the new state if it changed, or
-                          ``None`` if it did not.
-    :type execute_change: ``bool`` or ``None``
-    """
-
-
-class FileChanges(object):
-    """Contains information about which files changed in a revision.
-
-    Note that the 'files changed' information is relative to left-most parent
-    by default, as in 'bzr log -v'.
-
-    :ivar deltas: A list of `FileDelta` objects.
-    :ivar fileset: ``set(d.file_id for d in self.deltas)``, but cached.
-    """
-
-class RevisionInfo(object):
-    """Contains all the immutable information Loggerhead needs about a
-    particular revision.
-
-    :ivar revid: Obvious.
-    :ivar date: The date and time this revision was committed.
-    :type date: ``datetime.datetime``
-    :ivar committer: The committer.
-    :type committer: utf-8 encoded ``str``
-    :ivar revprops: The branch properties.
-    :type revprops: A dictionary mapping ``str``\ s to ``str``\ s (both utf-8
-                    encoded).
-    :ivar message: The commit message of this revision.
-    :type message: utf-8 encoded ``str``
-    :ivar parents: The list of the revids of the revision's parents.
-    """
-
-class BranchRevisionInfo(object):
-    """Contains all the mutable information Loggerhead needs about a
-    particular revision, and points to the immutable data.
-
-    :ivar revno: The dotted revno of this revision in this branch.
-    :type revno: ``str``
-    :ivar where_merged: The list of revids that have this revision as a
-                        parent.
-    :ivar info: The corresponding `RevisionInfo`.
-    """
-
-class FileEntry(object):
-    """An entry in the list returned by `getFileList`.
-
-    :ivar path: The path of the object in the revision passed to
-                `getFileList`.
-    :ivar fileid: Obvious.
-    :ivar kind: one of ``'file'``, ``'executable'``, ``'link'`` or
-                ``'directory'``.
-    :type kind: ``str``
-    :ivar last_changed_revid: The revid of the revision in which this path
-                              last changed.  Not that this is recursive,
-                              i.e. the last_changed_revid for a directory is
-                              the revid in which the directory or anything
-                              contained in in changed.x
-    :ivar size: The size of this object in this revision in bytes.
-    :type size: ``int``
-    """
-
-class History(object):
-    """Provide the information loggerhead needs about a bzrlib Branch.
-
-    An instance of this class is effectively a wrapper around a
-    `bzrlib.branch.Branch` that translates the information provided by bzrlib
-    into a form convenient for use in loggerhead.
-
-    :ivar last_revision: The revid of the tip of the branch.
-    """
-
-    @classmethod
-    def fromBranch(cls, branch):
-        """Create and initialize a `History` object from a
-        `bzrlib.branch.Branch`.
-        """
-
-    def outOfDate(self):
-        """Decide whether this History object is still current.
-
-        At least to start with, an out of date History object should be thrown
-        away and a fresh one created.
-        """
-
-    def getRevisionInfo(self, revid):
-        """Find the `BranchRevisionInfo` object for a given revision id.
-
-        This operation is to be thought of as 'cheap', which is to say that
-        you should not worry about calling it repeatedly with the same
-        argument or about calling it just to retrieve a subset of the
-        information it includes.
-
-        :param revid: a revision id.
-        :returns: a `BranchRevisionInfo` object or ``None`` if the given
-                  revision id does not exist in the branch.
-        """
-
-    def getChanges(self, revid, other_revid=None):
-        """Find the `FileChanges` object between two revision.
-
-        :param revid: A revision id.
-        :param other_revid: The revision id to compare against.  If ``None``
-                            or not given, compare against the leftmost parent
-                            of ``revid``.
-        :returns: The corresponding `FileChanges` object.
-        """
-
-    # There will need to be some more methods here to allow searching for
-    # revisions by date, committer, commit message, etc...
-
-    def getDiff(self, revidA, revidB):
-        """Compute the diff between two revisions.
-
-        Not sure what this will return yet, probably something similar to but
-        more structured than the 'chunks' loggerhead already works with.
-        """
-
-    def getDirList(self, fileid, revid):
-        """List the files in the given directory as of the given revision.
-
-        :return: a list of `FileEntry` objects.
-        """
-
-    def getFileAnnotation(self, fileid, revid):
-        """Annotate the given file.
-
-        Not sure what this should return, mostly likely a list of
-        (revid-or-None, line contents) (and ``None`` for a binary file).
-        """
-
-    def getFileText(self, fileid, revid):
-        """Fetch the contents of a file at a particular revision.
-
-        :returns: (filename, data)
-        :rtype: ``(str, str)``
-        """
-
-    def getBundle(self, revid, compare_revid=None):
-        """Return a bundle for this revision.
-
-        Relative to compare_revid, or left-most parent if this is not supplied
-        or None.
-
-        :return: A bundle (in a string).
-        """
-
-    def normalizeRevivionSpec(self, revspec):
-        """Convert a revid or revno or 'head' to a revid.
-
-        :returns: a revision id.
-        """
-
-    def normalizeFileArguments(self, revid, fileid, filepath):
-        """Handle various ways of specifying a file in the branch.
-
-        One of ``fileid`` and ``filepath`` should be None.
-
-        :returns: (fileid, filepath)
-        """

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-06-25 07:26:04 +0000
+++ loggerhead/static/css/style.css	2007-01-24 19:17:40 +0000
@@ -25,7 +25,7 @@
     color: #708a96;
     font-weight: normal;
     font-size: 1.6em;
-    margin-bottom: 1em;
+    margin-bottom: 1.5em;
 }
 h1 .filename {
     font-family: monospace;
@@ -201,65 +201,68 @@
 /* ----- changelog page ----- */
 
 /* secret css-jutsu to make hidden margins vanish on a table */
-.log-entries {
+.log-entries table {
     border-collapse: collapse;
-    width: 98%;
-    margin-top: 0.5em;
-    margin-left: 1em;
-}
-
-.log-entries .log-header {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
+    width: 100%;
 }
 
 .log-entries .revision-header {
-    font-size: normal;
-}
-
-.log-entries .revision-header td {
-    padding-top: 2px;
-    padding-bottom: 2px;
+    background-color: #dee7ec;
+    padding: 3px;
+    width: 80%;
+    margin-top: 1em;
+    margin-left: 1em;
 }
 
 .log-entries .revision-header td.expand-button {
     width: 20px;
 }
 
-.log-entries .revision-number {
+.log-entries .revision-header .revision-number {
+    width: 6em;
     padding-left: 0.5em;
 }
 
-.log-entries .revision-header td.date {
-    font-size: smaller;
-}
-
-.log-entries .revision-header td.author {
-    font-size: smaller;
-    padding-right: 0.5em;
-}
-
 .log-entries .revision-header .inventory-link {
     font-size: smaller;
     vertical-align: middle;
-    text-align: left;
+    width: 4em;
+    text-align: right;
     padding-right: 0.5em;
 }
 
-.log-entries table.revision-details {
+.log-entries .revision-details-block {
+    width: 80%;
+    border: none;
+    margin-left: 8em;
+    margin-bottom: 1.5em;
+}
+
+.log-entries .revision-details table {
     font-size: smaller;
-    margin-bottom: 1.0em;
+    width: 100%;
 }
 
-.log-entries table.revision-details th {
+.log-entries .revision-details th {
+    width: 8em;
     text-align: right;
     padding-right: 0.5em;
     vertical-align: top;
 }
 
-.log-entries table.revision-details td.files .filename {
+.log-entries .revision-details td.date {
+/*    font-family: monospace; */
+}
+
+.log-entries .revision-details th.files {
+    padding-top: 1em;
+}
+
+.log-entries .revision-details td.files {
+    padding-top: 1em;
+}
+
+.log-entries .revision-details td.files .filename {
     font-family: monospace;
 }
 
@@ -267,8 +270,12 @@
     font-size: smaller;
 }
 
+.log-entries .revision-details th.description {
+    padding-top: 1em;
+}
 .log-entries .revision-details td.description {
     font-family: monospace;
+    padding-top: 1em;
 }
 
 /* default state: hide all */
@@ -463,7 +470,7 @@
 
 table.inventory {
     border-collapse: collapse;
-    width: 100%;
+    width: 80%;
     font-size: smaller;
     margin-top: 1em;
     border: 1px solid #8cacbb;
@@ -491,8 +498,8 @@
 
 .inventory td.permissions {
     font-family: monospace;
-    padding-left: 0.5em;
     width: 9em;
+    padding-left: 0.5em;
 }
 
 .inventory td.filename {
@@ -500,30 +507,31 @@
 }
 
 .inventory td.size {
-    font-family: monospace;
-    font-size: smaller;
-    width: 5em;
+	font-family: monospace;
+	font-size: smaller;
+	width: 5em;
 }
 
 .inventory td.revision {
-    padding-right: 1em;
-    text-align: left;
     width: 8em;
+    padding-right: 1.5em;
 }
 
 .inventory td.date {
-    padding-right: 1em;
+    font-family: monospace;
+    font-size: smaller;
     width: 10em;
+    padding-right: 1.5em;
 }
 
 .inventory td.changes-link {
+    width: 6em;
     font-size: smaller;
-    width: 6em;
 }
 
 .inventory td.download-link {
+    width: 8em;
     font-size: smaller;
-    width: 8em;
 }
 
 span.folder {
@@ -631,23 +639,23 @@
 }
 
 .browse-view td,.browse-view th {
-    padding: 0.25em 0.5em 0.25em 0.5em;
+	padding: 0.25em 0.5em 0.25em 0.5em;
 }
 
 .browse-view td.name {
-    width: 20%;
+	width: 20%;
 }
 
 .browse-view td.last-update {
-    font-size: smaller;
-    width: 20em;
+	font-size: smaller;
+	width: 15%;
 }
 
 .browse-view td.url {
-    font-family: monospace;
-    font-size: smaller;
-    padding-left: 3em;
-    padding-top: 0px;
+	font-family: monospace;
+	font-size: smaller;
+	padding-left: 3em;
+	padding-top: 0px;
 }
 
 .browse-view td.feed {

=== removed file 'loggerhead/static/css/zptstyle.css'
--- loggerhead/static/css/zptstyle.css	2007-07-04 15:19:45 +0000
+++ loggerhead/static/css/zptstyle.css	1970-01-01 00:00:00 +0000
@@ -1,657 +0,0 @@
-
-/* from launchpad */
-body {
-    background-color: #fcfcfc;
-    color: black;
-    font-family: "Lucida Grande", "Trebuchet MS", sans-serif;
-    font-size: 12pt;
-    padding: 0px;
-    text-align: left;
-}
-
-a {
-    text-decoration: none;
-    color: #000088;
-}
-a:hover {
-    color: black;
-}
-
-img {
-    border: none;
-}
-
-h1 {
-    color: #708a96;
-    font-weight: normal;
-    font-size: 1.6em;
-    margin-bottom: 0em;
-}
-h1 .filename {
-    font-family: monospace;
-}
-
-.branch-name {
-    color: #47626e;
-}
-
-.footer {
-    margin-top: 1em;
-    margin-bottom: 1em;
-}
-.footer .banner {
-    margin-right: 5px;
-}
-.footer .banner img {
-    border: 1px solid #8cacbb;
-}
-
-.collapse-triangle {
-    padding-right: 0.5em;
-}
-
-.hide-all {
-    font-size: smaller;
-    padding: 0.25em 0.75em 0.25em 0.75em;
-}
-
-
-
-/* ----- navigation bar at the top ----- */
-
-.navbar {
-}
-
-.bar table {
-    width: 100%;
-    border-collapse: collapse;
-}
-
-/* safari gives forms a big default margin, to vex me */
-.bar form {
-    margin: 0px;
-}
-
-.bar {
-    background-color: #dee7ec;
-    border: 1px solid #8cacbb;
-    font-size: smaller;
-    padding-top: 0px;
-    padding-bottom: 0px;
-}
-
-/* revision navigation buttons (the ones at the top right) */
-.navbuttons {
-    padding: 2px;
-    bottom: 0px;
-    text-align: right;
-    width: auto;
-    border-left: 1px dotted #8cacbb;
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-}
-
-.navbuttons a {
-    font-weight: normal;
-    margin-left: 2px;
-    margin-right: 2px;
-}
-
-.navbuttons a:hover {
-    padding: 0;
-    color: blue;
-}
-
-/* navigation button in the pages (the ones at the top left, and bottom) */
-.buttons {
-}
-
-.buttons a,.buttons .search {
-    font-weight: normal;
-    color: #000088;
-    font-size: 12pt;
-    padding-left: 10px;
-    padding-right: 7px;
-    border-right: 1px dotted #8cacbb;
-}
-
-.buttons a:hover,.rbuttons a:hover {
-    font-weight: normal;
-    color: blue;
-}
-
-.feed img {
-    vertical-align: text-top;
-}
-
-.rbuttons a {
-    font-weight: normal;
-    color: #000088;
-    font-size: 12pt;
-    padding-right: 7px;
-    padding-left: 10px;
-    border-left: 1px dotted #8cacbb;
-    text-align: right;
-    width: auto;
-}
-
-
-/* ----- revision display in various places ----- */
-
-.revision .revno {
-    font-weight: bold;
-}
-
-.revision .revid {
-    font-family: monospace;
-    font-size: smaller;
-    padding-left: 1em;
-}
-
-.revision .log {
-    font-size: smaller;
-}
-
-
-/* ---- sub-links underneath the headline on some pages ----- */
-
-div.links {
-    color: #708a96;
-    padding-top: 0.5em;
-    padding-left: 3em;
-    font-size: 0.8em;
-    margin-bottom: 2em;
-}
-
-div.links div {
-    margin-bottom: 3px;
-}
-
-
-/* ----- list of merge points for a revision ----- */
-
-.info-entry {
-    font-size: smaller;
-    margin-bottom: 2em;
-    padding: 0px;
-    background-color: #f4f5f8;
-    border: 1px solid #8cacbb;
-    width: 60%;
-}
-
-.info-entry th {
-    background-color: #dee7ec;
-    font-weight: normal;
-    color: black;
-    text-align: right;
-    vertical-align: top;
-
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.info-entry td {
-    font-weight: normal;
-    padding-left: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-
-/* ----- changelog page ----- */
-
-/* secret css-jutsu to make hidden margins vanish on a table */
-.log-entries {
-    border-collapse: collapse;
-    width: 98%;
-    margin-top: 0.5em;
-    margin-left: 1em;
-}
-
-.log-entries .log-header {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
-}
-
-.log-entries .revision-header {
-    font-size: normal;
-}
-
-.log-entries .revision-header td {
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.log-entries .revision-header td.expand-button {
-    width: 20px;
-}
-
-.log-entries .revision-number {
-    padding-left: 0.5em;
-}
-
-.log-entries .revision-header td.date {
-    font-size: smaller;
-}
-
-.log-entries .revision-header td.author {
-    font-size: smaller;
-    padding-right: 0.5em;
-}
-
-.log-entries .revision-header .inventory-link {
-    font-size: smaller;
-    vertical-align: middle;
-    text-align: left;
-    padding-right: 0.5em;
-}
-
-.log-entries table.revision-details {
-    font-size: smaller;
-    margin-bottom: 1.0em;
-}
-
-.log-entries table.revision-details th {
-    text-align: right;
-    padding-right: 0.5em;
-    vertical-align: top;
-}
-
-.log-entries table.revision-details td.files .filename {
-    font-family: monospace;
-}
-
-.log-entries .revision-details td.files .jump {
-    font-size: smaller;
-}
-
-.log-entries .revision-details td.description {
-    font-family: monospace;
-}
-
-/* default state: hide all */
-.revision-header .hide-button { display: none; }
-.hidden-details { display: none; }
-.changelog .collapse-cl-hideall { display: none; }
-
-
-/* ----- revision page ----- */
-
-.revision-info {
-    border: none;
-    font-size: smaller;
-    margin-bottom: 1em;
-    padding: 0;
-    background-color: #f4f5f8;
-    border: 1px solid #8cacbb;
-    width: 80%;
-}
-
-/* secret css-jutsu to make hidden margins vanish on a table */
-.revision-info table {
-    border-collapse: collapse;
-    width: 100%;
-}
-
-.revision-info th {
-    background-color: #dee7ec;
-    color: black;
-    font-weight: normal;
-    text-align: right;
-    vertical-align: top;
-    
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.revision-info td {
-    font-weight: normal;
-    padding-left: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.revision-info table td.date {
-    font-family: monospace;
-}
-
-.revision-info table td.description {
-    font-family: monospace;
-}
-
-.revision-info table td.files .filename {
-    font-family: monospace;
-}
-
-.revision-info table td.files a.jump {
-    font-size: smaller;
-}
-    
-.revision-info table tr.divider {
-    border-top: 1px solid #8cacbb;
-}
-
-
-/* ----- overly complex diff display ----- */
-
-.diff {
-    margin-bottom: 1em;
-    padding-top: 10px;
-    width: 100%;
-    background-color: #fcfcfc;
-    font-family: monospace;
-}
-
-
-.diff-block {
-    border-collapse: collapse;
-    width: 100%;
-    margin-bottom: 1em;
-}
-
-.diff-block th.filename {
-    font-family: monospace;
-    font-weight: normal;
-    font-size: smaller;
-    padding-left: 1em;
-    padding-top: 1em;
-    padding-bottom: 1em;
-    text-align: left;
-    background-color: #dee7ec;
-}
-
-.diff-block .diff-chunk {
-    font-size: 66%;
-    margin-top: 0px;
-    margin-bottom: 2em;
-}
-
-.diff-block th.lineno {
-    font-weight: bold;
-    border-bottom: 1px solid #8cacbb;
-    border-top: 1px solid #dee7ec;
-}
-
-.diff-block .diff-spacing {
-    line-height: 1em;
-}
-
-.diff-option-buttons {
-    margin-top: 1.0em;
-    margin-bottom: 1.0em;
-    border-collapse: collapse;
-}
-.diff-option-buttons td {
-    line-height: 1em;
-    height: 1em;
-    vertical-align: middle;
-    padding: 0px;
-}
-.diff-option-buttons .label {
-    font-size: smaller;
-    padding-left: 0.75em;
-    padding-right: 2em;
-    line-height: 1em;
-}
-.diff-option-buttons .spacey {
-    padding-right: 5em;
-}
-
-.diff-option-buttons .collapse-file-showall { display: none; }
-
-.diff-block .show-button { display: none; }
-.diff .collapse-style-unified-content { display: none; }
-.collapse-style-sbs-show { display: none; }
-
-.diff-insert {
-    background-color: #9cc8ff;
-}
-.diff-delete {
-    background-color: #ffa0a0;
-}
-.diff-chunk td.text {
-    padding-left: 1em;
-}
-
-.diff-key {
-    display: inline;
-    font-size: smaller;
-}
-
-.diff-key-block {
-    width: 1em;
-    height: 1em;
-    border: 1px solid #8cacbb;
-}
-
-.diff-key .label {
-    padding-right: 2em;
-}
-
-.diff .lineno {
-    color: purple;
-    background-color: #dee7ec; 
-    width: 4em;
-    text-align: right;
-    padding-right: 3px;
-    border-bottom: 1px solid #8cacbb;
-}
-.diff .lineno-skip {
-    width: 4em;
-    background-color: #dee7ec;
-}
-.diff .info {
-    color: blue;
-    background-color: #dee7ec;
-    margin-top: 15px;
-}
-/*
-.diff-context-skip {
-    background-color: #dee7ec;
-}*/
-
-
-/* ----- file inventory ----- */
-
-.inventory-path {
-    margin-top: 2em;
-}
-
-table.inventory {
-    border-collapse: collapse;
-    width: 100%;
-    font-size: smaller;
-    margin-top: 1em;
-    border: 1px solid #8cacbb;
-}
-
-table.inventory td {
-    padding-top: 3px;
-    padding-bottom: 3px;
-    vertical-align: middle;
-}
-
-table.inventory th {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
-}
-
-table.inventory th.permissions {
-    padding-left: 0.5em;
-}
-
-.parity0 { background-color: #dee7ec; }
-.parity1 { background-color: #eff8fd; }
-
-.inventory td.permissions {
-    font-family: monospace;
-    padding-left: 0.5em;
-    width: 9em;
-}
-
-.inventory td.filename {
-    font-family: monospace;
-}
-
-.inventory td.size {
-    font-family: monospace;
-    font-size: smaller;
-    width: 5em;
-}
-
-.inventory td.revision {
-    padding-right: 1em;
-    text-align: left;
-    width: 8em;
-}
-
-.inventory td.date {
-    padding-right: 1em;
-    width: 10em;
-}
-
-.inventory td.changes-link {
-    font-size: smaller;
-    width: 6em;
-}
-
-.inventory td.download-link {
-    font-size: smaller;
-    width: 8em;
-}
-
-span.folder {
-    font-family: monospace;
-}
-
-
-/* ----- file annotation ----- */
-
-.annotate-path {
-    font-family: monospace;
-}
-
-.annotate table {
-    border-collapse: collapse;
-    width: 100%;
-    font-size: 66%;
-}
-
-.annotate td {
-    padding-top: 2px;
-    padding-bottom: 2px;
-    vertical-align: bottom;
-}
-
-.annotate td.lineno {
-    font-family: monospace;
-    text-align: right;
-    width: 4em;
-    padding-right: 5px;
-    font-weight: bold;
-    border-bottom: 1px solid #8cacbb;
-}
-
-.annotate td.revno {
-    font-family: monospace;
-    text-align: right;
-    width: 8em;
-    padding-right: 5px;
-    border-right: 1px solid #8cacbb;
-}
-
-.annotate td.text {
-    font-family: monospace;
-    padding-left: 1em;
-}
-
-.annotate th {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
-}
-
-.annotate th.lineno {
-    text-align: right;
-}
-
-.annotate th.revision {
-    text-align: right;
-    padding-right: 5px;
-}
-
-.annotate th.text {
-    padding-left: 1em;
-}
-
-
-/* ----- top-level browse page ----- */
-
-.browse-project-name {
-    background-color: #dee7ec;
-    padding-top: 5px;
-    padding-bottom: 5px;
-    margin-left: 1em;
-    margin-right: 1em;
-    padding-left: 1em;
-    width: 90%;
-    font-weight: bold;
-}
-
-.browse-project-description {
-	padding-top: 1em;
-	padding-bottom: 1em;
-	margin-left: 2em;
-    width: 90%;
-}
-	
-.browse-view {
-	margin-top: 1em;
-	margin-bottom: 1em;
-	margin-left: 2em;
-}
-
-.browse-view table {
-    border-collapse: collapse;
-    width: 90%;
-    margin-bottom: 2em;
-}
-
-.browse-view table tr.heading {
-    background-color: #8cacbb;
-    border-bottom: solid 1px #8cacbb;
-    font-size: smaller;
-}
-
-.browse-view td,.browse-view th {
-    padding: 0.25em 0.5em 0.25em 0.5em;
-}
-
-.browse-view td.name {
-    width: 20%;
-}
-
-.browse-view td.last-update {
-    font-size: smaller;
-    width: 20em;
-}
-
-.browse-view td.url {
-    font-family: monospace;
-    font-size: smaller;
-    padding-left: 3em;
-    padding-top: 0px;
-}
-
-.browse-view td.feed {
-	width: 16px;
-}

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2007-06-21 16:39:33 +0000
+++ loggerhead/templates/annotate.kid	2007-01-21 00:05:52 +0000
@@ -15,7 +15,7 @@
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> download file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
 	</div>
 </h1>
 
@@ -28,12 +28,12 @@
         </tr>
 
         <tr py:for="line in contents" class="parity${line.parity}">
-            <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
+            <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
                 <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
                     title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
-            <td class="text ${line.status}"> ${line.text} </td>
+            <td class="text ${line.status}"> ${XML(line.text)} </td>
         </tr>
     </table>
 </div>

=== removed file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2007-07-05 09:10:39 +0000
+++ loggerhead/templates/annotate.pt	1970-01-01 00:00:00 +0000
@@ -1,100 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml">
-  <head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
-    <title>
-      <tal:branch-name content="branch/friendly_name">
-        ${branch.friendly_name}
-      </tal:branch-name>
-      : contents of
-      <tal:path content="path">
-        ${path}
-      </tal:path>
-      at revision
-      <tal:revno content="change/revno">
-        ${change.revno}
-      </tal:revno>
-    </title>
-    <link rel="stylesheet"
-          tal:attributes="href python:tg.url('/static/css/zptstyle.css')" />
-  </head>
-
-  <body>
-
-    <tal:navigation content="structure here/navigation.pt" />
-
-    <h1>
-      <span class="branch-name" tal:content="branch/friendly_name">
-        ${branch.friendly_name}
-      </span>
-      :
-      <span class="annotate-path" tal:content="path">
-        ${path}
-      </span>
-      (revision <tal:revno content="change/revno">${change.revno}</tal:revno>)
-    </h1>
-    <div class="links">
-      <div>
-        <b>&#8594;</b>
-        <a tal:attributes="href python:branch.url([ '/files', revid ], **util.get_context(clear=1))">
-          browse files
-        </a>
-      </div>
-      <div>
-        <b>&#8594;</b>
-        <a tal:attributes="href python:branch.url('/revision', **util.get_context(clear=1, start_revid=revid))">
-          view revision
-        </a>
-      </div>
-      <div>
-        <b>&#8594;</b>
-        <a tal:attributes="href python:branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))">
-          view changes to this file
-        </a>
-      </div>
-      <div>
-        <b>&#8594;</b>
-        <a tal:attributes="href python:branch.url([ '/download', revid, file_id, filename ])">
-          download file
-        </a>
-      </div>
-    </div>
-
-    <div class="annotate">
-      <table>
-        <tr>
-          <th class="lineno"> Line# </th>
-          <th class="revision"> Revision </th>
-          <th class="text"> Contents </th>
-        </tr>
-
-        <tr tal:repeat="line contents"
-            tal:attributes="class string:parity${line/parity}">
-          <td tal:attributes="class string:lineno ${line/status}">
-            <a tal:attributes="name string:L${line/lineno}"
-               tal:content="line/lineno">
-              ${line.lineno}
-            </a>
-          </td>
-          <td tal:attributes="class string:revno ${line/status}">
-            <a tal:condition="python:line.status=='changed'"
-               tal:content="python:util.trunc(line.change.revno)"
-               tal:attributes="href python:branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id));
-                               title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.ago(line.change.date))">
-
-              ${util.trunc(line.change.revno)}
-            </a>
-          </td>
-          <td tal:attributes="class string:text ${line/status}"
-              tal:content="line/text">
-            ${line.text}
-          </td>
-        </tr>
-      </table>
-    </div>
-
-    <tal:footer content="structure here/footer.pt" />
-
-  </body>
-</html>

=== modified file 'loggerhead/templates/atom.kid'
--- loggerhead/templates/atom.kid	2007-03-29 06:55:55 +0000
+++ loggerhead/templates/atom.kid	2006-12-20 21:24:32 +0000
@@ -2,18 +2,17 @@
 <feed xmlns="http://www.w3.org/2005/Atom" xmlns:py="http://purl.org/kid/ns#">
     <title> bazaar changes for ${branch.friendly_name} </title>
     <updated>${updated}</updated>
-    <id>${branch.url(['atom'])}</id>
-    <link rel="self" href="${branch.url([''])}" />
+    <id>${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}</id>
+    <link rel="self" href="${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}" />
 
 	<entry py:for="entry in changes">
 	    <title> ${entry.revno}: ${entry.short_comment} </title>
 	    <updated>${entry.date.isoformat() + 'Z'}</updated>
-	    <id>${branch.url(['revision', entry.revid ])}</id>
+	    <id>${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}</id>
 	    <author> <name> ${util.hide_email(entry.author)} </name> </author>
 	    <content type="text">
             ${entry.comment}
 	    </content>
-	    <link rel="alternate"
-                  href="${branch.url(['revision', entry.revid ])}" />
+	    <link rel="alternate" href="${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}" />
 	</entry>
 </feed>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2007-06-08 11:52:33 +0000
+++ loggerhead/templates/browse.kid	2007-01-21 00:05:52 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().last_revid and util.ago(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${util.ago(view.last_updated())} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2007-06-26 05:34:28 +0000
+++ loggerhead/templates/changelog.kid	2007-01-21 00:05:52 +0000
@@ -31,100 +31,85 @@
     Sorry, no results found for your search.
 </span>
 
-<span py:if="not changes">
-    No revisions!
-</span>
-
 <span py:if="not search_failed" class="changelog"> ${collapse_all_button('cl')} </span>
 
-<table class="log-entries">
-    <tr class="log-header">
-        <th class="revision-number">Rev</th>
-        <th></th>
-        <th class="summary">Summary</th>
-        <span py:strip="True" py:if="all_same_author">
-            <th></th>
-        </span>
-        <span py:strip="True" py:if="not all_same_author">
-            <th class="author">Committer</th>
-        </span>
-        <th class="date" colspan="2">Date</th>
-    </tr>
+<div class="log-entries">
     <div py:for="entry in changes" class="revision">
         <a name="entry-${entry.revno}" />
-        <tr class="revision-header parity${entry.parity}">
-            <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
-            <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
-            <td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
-            <span py:strip="True" py:if="all_same_author">
-                <td></td>
-            </span>
-            <span py:strip="True" py:if="not all_same_author">
-                <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
-            </span>
-            <td class="date"> ${entry.date.strftime('%Y-%m-%d, %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
-            <td class="inventory-link"> 
-                <a href="${branch.url([ '/files', entry.revid ])}"
-                    title="Files at revision ${entry.revno}"> files</a>
-            </td>
-        </tr>
+        <div class="revision-header">
+            <table>
+                <tr>
+                    <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
+                    <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
+					<td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
+					<td class="inventory-link"> <a href="${branch.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
+				</tr>
+			</table>
+        </div>
         
-        <tr class="revision-details-block parity${entry.parity}">
-            <td colspan="2"></td>
-            <td colspan="4"><table class="revision-details hidden-details collapse-cl-${entry.revno}-content">
-                <tr py:if="len(entry.merge_points) > 0">
-                    <th class="children"> merged in: </th>
-                    <td class="children">
-                        <span py:for="child in entry.merge_points">
-                            ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
-                        </span>
-                    </td>
-                </tr>
-                <tr py:if="len(entry.parents) > 1">
-                    <th class="parents"> merged from: </th>
-                    <td class="parents">
-                        <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
-                            ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
-                        </span></span>
-                    </td>
-                </tr>
-                <span py:strip="True" py:if="all_same_author">
-                    <tr>
-                        <th class="author">committed by:</th>
-                        <td class="author"> ${util.hide_email(entry.author)} </td>
-                    </tr>
-                </span>
-                <tr>
-                    <th class="description">description:</th>
-                    <td class="description"><span py:for="line in entry.comment_clean">${XML(line)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.added">
-                    <th class="files"> files added: </th>
-                    <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.removed">
-                    <th class="files"> files removed: </th>
-                    <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.renamed">
-                    <th class="files"> files renamed: </th>
-                    <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
-                        ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
-                    </span> </td>
-                </tr>
-                <tr py:if="entry.changes.modified">
-                    <th class="files"> files modified: </th>
-                    <td class="files"> <span py:for="item in entry.changes.modified">
-                        <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
-                        <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
-                        <br />
-                    </span> </td>
-                </tr>
-                </table>
-            </td>
-        </tr>
+        <div class="revision-details-block">
+            <div class="revision-details">
+			    <table>
+			        <tr>
+			            <th class="author">committed by:</th>
+			            <td class="author"> ${util.hide_email(entry.author)} </td>
+			        </tr>
+			        <tr>
+			            <th class="date">date:</th>
+			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
+			        </tr>
+			    </table>
+			</div>
+	        <div class="revision-details hidden-details collapse-cl-${entry.revno}-content">
+		        <table>
+			        <tr py:if="len(entry.merge_points) > 0">
+			            <th class="children"> merged in: </th>
+			            <td class="children">
+			                <span py:for="child in entry.merge_points">
+			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
+			                </span>
+			            </td>
+			        </tr>
+			        <tr py:if="len(entry.parents) > 1">
+			        	<th class="parents"> merged from: </th>
+			        	<td class="parents">
+			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
+			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
+			        	    </span></span>
+			        	</td>
+			        </tr>
+
+			        <tr py:if="entry.changes.added">
+			            <th class="files"> files added: </th>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.removed">
+			            <th class="files"> files removed: </th>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.renamed">
+			            <th class="files"> files renamed: </th>
+			            <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
+			                ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
+			            </span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.modified">
+			            <th class="files"> files modified: </th>
+			            <td class="files"> <span py:for="item in entry.changes.modified">
+			                <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
+			                <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
+			                <br />
+			            </span> </td>
+			        </tr>
+			        <tr>
+			            <th class="description">description:</th>
+		                <td class="description"><span py:for="line in entry.comment_clean">${XML(line)} <br /></span> </td>
+		            </tr>
+		        </table>
+	    	</div>
+        </div>
     </div>
-</table>
+</div>
 
 <div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
     <table>

=== removed file 'loggerhead/templates/footer.pt'
--- loggerhead/templates/footer.pt	2007-07-04 15:55:56 +0000
+++ loggerhead/templates/footer.pt	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-<div class="footer">
-  <span class="banner">
-    <a href="http://www.bazaar-vcs.org/">
-      <img tal:attributes="src python:tg.url('/static/images/bazaar-banner.png')" />
-    </a>
-  </span>
-  <span class="banner">
-    <a href="http://www.lag.net/loggerhead/">
-      <img tal:attributes="src python:tg.url('/static/images/loggerhead-banner.png')" />
-    </a>
-  </span>
-</div>
\ No newline at end of file

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2007-06-25 06:44:52 +0000
+++ loggerhead/templates/inventory.kid	2007-01-24 19:26:50 +0000
@@ -63,11 +63,11 @@
     <tr class="header">
         <th class="permissions"> Permissions </th>
         <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
-        <th> Latest Rev </th>
-        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">Last Changed</a> </th>
         <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
-        <th>  </th>
-        <th>  </th>
+        <th> Last change </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">When</a> </th>
+        <th> History </th>
+        <th> Download </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
@@ -86,16 +86,16 @@
             <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
                 **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
+        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
-        <td class="date"> ${file.change.date.strftime('%Y-%m-%d, %H:%M')} </td>
-        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
+        <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
         <td class="changes-link"> 
             <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
-               title="Changes affecting ${file.filename} up to revision ${file.change.revno}"> changes </a>
+               title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
         </td>
         <td class="download-link">
             <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"
-               title="Download ${file.filename} at revision ${file.change.revno}">  download </a></td>
+               title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
     </tr>
 </table>
 

=== removed file 'loggerhead/templates/master.pt'
--- loggerhead/templates/master.pt	2007-07-04 14:51:40 +0000
+++ loggerhead/templates/master.pt	1970-01-01 00:00:00 +0000
@@ -1,120 +0,0 @@
-<metal:page define-macro="master">
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml">
-
-  <head>
-    <meta content="text/html; charset=UTF-8" http-equiv="content-type" tal:replace="nothing"/>
-    <title tal:content="view/title">Your title goes here</title>
-    <meta py:replace="item[:]"/>
-    <style type="text/css" media="screen"
-           tal:content="string:@import url(${tg.url('/static/css/style.css')});">
-@import url(/static/css/style.css);
-    </style>
-
-<!-- !define common navbar -->
-<span py:def="navbar()" py:strip="True">
-    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="bar" py:if="navigation is not None">
-        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
-        <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
-              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
-            <td><span class="buttons">
-                <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
-                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
-                <span class="search"> search: <input type="text" name="q" /> </span>
-            </span></td>
-            <td align="right" py:if="hasattr(navigation, 'revid_list')">
-                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
-                    <a href="${branch.url('/atom')}">
-                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                </span>
-                <span class="navbuttons">
-                	<span py:if="navigation.prev_page_revid">
-                	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-                    </span>
-                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
-                    revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>
-                    ${navigation.page_position} / ${navigation.page_count})
-                	<span py:if="navigation.next_page_revid">
-                    <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-                    </span>
-                	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                </span>
-            </td>
-        </tr></table></form>
-    </div>
-</span>
-
-<metal:revlink metal:define-macro="revision-link">
-  <tal:comment replace="nothing">
-    This macro expects the following variables:
-    :revid:
-    :text:
-    :history:
-    :branch:
-    :overrides: ???
-  </tal:comment>
-    <a tal:attributes="title string:Show revision ${history.get_revno(revid)}
-                       href string:${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"
-       tal:content="text"
-       href="/branch/revision/$revid">
-      $text
-    </a>
-  </metal:revlink>
-
-<!-- ! expand button functions: -->
-
-	<span py:strip="True" py:def="use_collapse_buttons()">
-		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
-	    <a class="hide-all collapse-${group}-hideall"
-	       href="javascript:collapseAllDisplay('${group}','none')">
-	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
-	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />collapse all</a>
-	    <a class="hide-all collapse-${group}-showall"
-	       href="javascript:collapseAllDisplay('${group}','${normal}')">
-	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
-	             width="10" height="10" alt="expand"
-	             class="collapse-triangle" />expand all</a>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
-	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
-	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
-	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
-	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />
-	    </a>
-	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
-	       class="show-button collapse-${group}-${name}-show" title="expand">
-	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
-	    	     witdh="10" height="10" alt="expand"
-	    	     class="collapse-triangle" />
-	    </a>
-	</span>
-
-</head>
-
-<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
-      py:attrs="item.items()">
-
-    <div py:replace="[item.text]+item[:]"/>
-
-	<!-- End of main_content -->
-	
-	<div class="footer">
-	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
-	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
-	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
-	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
-	</div>
-</body>
-
-</html>

=== removed file 'loggerhead/templates/navigation.pt'
--- loggerhead/templates/navigation.pt	2007-07-04 16:00:18 +0000
+++ loggerhead/templates/navigation.pt	1970-01-01 00:00:00 +0000
@@ -1,37 +0,0 @@
-<div class="bar">
-  <form tal:attributes="action python:branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), file_id=getattr(navigation, 'file_id', None))">
-    <table>
-      <tr>
-        <td>
-          <span class="buttons">
-            <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
-            <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
-            <span class="search">
-              search: <input type="text" name="q" />
-            </span>
-          </span>
-        </td>
-        <td align="right" tal:condition="navigation/revid_list|nothing">
-          <span tal:condition="navigation/feed" class="rbuttons feed">
-            <a href="${branch.url('/atom')}">
-              <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" />
-            </a>
-          </span>
-          <span class="navbuttons">
-            <span tal:condition="navigation/prev_page_revid">
-              <a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-            </span>
-            <span tal:condition="python:not navigation.prev_page_revid"> &#171; </span>
-            revision ${history.get_revno(revid)}
-            (<span tal:condition="python:navigation.pagesize > 1">page </span>
-            ${navigation.page_position} / ${navigation.page_count})
-            <span tal:condition="navigation/next_page_revid">
-              <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-            </span>
-            <span tal:condition="python:not navigation.next_page_revid"> &#187; </span>
-          </span>
-        </td>
-      </tr>
-    </table>
-  </form>
-</div>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-06-26 06:28:36 +0000
+++ loggerhead/templates/revision.kid	2007-01-24 19:26:50 +0000
@@ -9,10 +9,6 @@
         <a href="${branch.url([ '/annotate', revid ],
             **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
-    <span py:strip="True" py:def="file_link_rev(filename, file_id, revid)">
-        <a href="${branch.url([ '/annotate', revid ],
-            **util.get_context(file_id=file_id))}" title="Annotate ${filename} at revision ${history.get_revno(revid)}">${filename}</a>
-    </span>
     
     <span py:replace="use_collapse_buttons()"></span>
     
@@ -113,9 +109,7 @@
         </tr>
         <tr py:if="change.changes.removed">
             <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">
-                ${file_link_rev(filename, file_id, change.parents[0].revid)} <br /></span>
-            </td>
+            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">${file_link(filename, file_id)} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.renamed">
             <th class="files"> files renamed: </th>
@@ -126,11 +120,8 @@
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
-                <span py:for="item in change.changes.modified" class="collapse-style-sbs-content">
-                    <a href="#${item.filename}-s" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
-                </span>
-                <span py:for="item in change.changes.modified" class="collapse-style-unified-content">
-                    <a href="#${item.filename}-u" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
+                <span py:for="item in change.changes.modified">
+                    <span class="filename">${file_link(item.filename, item.file_id)}</span> &nbsp; <a href="#${item.filename}" class="jump">&#8594; diff</a><br />
                 </span>
             </td>
         </tr>
@@ -164,8 +155,7 @@
         <span py:strip="True" py:for="item in change.changes.modified">
             <tr><th class="filename" colspan="4">
                 ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}"
-                    name="${item.filename}-s" title="Annotate ${item.filename}">${item.filename}</a>
+                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
             </th></tr>
 
             <span py:strip="True" py:for="chunk in item.sbs_chunks">
@@ -175,19 +165,19 @@
                 <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
                     <span py:if="line.old_lineno" py:strip="True">
                         <td class="lineno">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}">${line.old_line}</td>
+                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
                     </span>
                     <span py:if="not line.old_lineno" py:strip="True">
                         <td class="lineno-skip">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}-skip">${line.old_line}</td>
+                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
                     </span>
                     <span py:if="line.new_lineno" py:strip="True">
                         <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}">${line.new_line}</td>
+                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
                     </span>
                     <span py:if="not line.new_lineno" py:strip="True">
                         <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}-skip">${line.new_line}</td>
+                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
                     </span>
                 </tr>
                 <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
@@ -198,25 +188,24 @@
     
     <!-- ! unified diff -->
     <table class="diff-block collapse-style-unified-content">
-        <span py:strip="True" py:for="item in change.changes.modified">
-            <tr><th class="filename" colspan="4">
-                ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}"
-                    name="${item.filename}-u" title="Annotate ${item.filename}">${item.filename}</a>
-            </th></tr>
-
-            <span py:strip="True" py:for="chunk in item.chunks">
-                <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
-                <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
-                    <td class="lineno">${line.old_lineno}</td>
-                    <td class="lineno">${line.new_lineno}</td>
-                    <td class="diff-${line.type} text">${line.line}</td>
-                    <td> </td>
-                </tr>
-                <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
-            </span>
-            <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
-        </span>
+	    <span py:strip="True" py:for="item in change.changes.modified">
+	        <tr><th class="filename" colspan="4">
+	            ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
+	            <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+	        </th></tr>
+	
+	        <span py:strip="True" py:for="chunk in item.chunks">
+	            <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
+	            <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
+	                <td class="lineno">${line.old_lineno}</td>
+	                <td class="lineno">${line.new_lineno}</td>
+	                <td class="diff-${line.type} text">${XML(line.line)}</td>
+	                <td> </td>
+	            </tr>
+	            <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
+	        </span>
+	        <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
+	    </span>
     </table>
 
 </div>

=== added file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_controllers.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,16 @@
+from turbogears import testutil
+from loggerhead.controllers import Root
+import cherrypy
+
+cherrypy.root = Root()
+
+def test_method():
+    "the index method should return a string called now"
+    import types
+    result = testutil.call(cherrypy.root.index)
+    assert type(result["now"]) == types.StringType
+
+def test_indextitle():
+    "The mainpage should have the right title"
+    testutil.createRequest("/")
+    assert "<TITLE>Welcome to TurboGears</TITLE>" in cherrypy.response.body[0]

=== removed file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2007-06-27 15:38:47 +0000
+++ loggerhead/tests/test_corners.py	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-from loggerhead.tests.test_simple import BasicTests
-
-import os
-from turbogears import testutil
-import cherrypy
-
-class TestCornerCases(BasicTests):
-
-    def test_survive_over_upgrade(self):
-        self.createBranch()
-
-        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        try:
-            f.write("foo")
-        finally:
-            f.close()
-        self.tree.add('myfilename')
-        msg = 'a very exciting commit message'
-        self.tree.commit(message=msg)
-
-        self.setUpLoggerhead()
-
-        testutil.create_request('/project/branch/changes')
-        assert msg in cherrypy.response.body[0]
-
-        from bzrlib.upgrade import upgrade
-        from bzrlib.bzrdir import format_registry
-        upgrade(self.bzrbranch, format_registry.make_bzrdir('dirstate-tags'))
-
-        testutil.create_request('/project/branch/changes')
-        assert msg in cherrypy.response.body[0]
-
-    def test_revision_only_changing_execute_bit(self):
-        self.createBranch()
-
-        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        try:
-            f.write("foo")
-        finally:
-            f.close()
-        self.tree.add('myfilename')
-        msg = 'a very exciting commit message'
-        self.tree.commit(message=msg)
-
-        os.chmod(os.path.join(self.bzrbranch, 'myfilename'), 0755)
-
-        newrevid = self.tree.commit(message='make something executable')
-
-        self.setUpLoggerhead()
-
-
-        testutil.create_request('/project/branch/revision/'+newrevid)
-        assert 'executable' in cherrypy.response.body[0]

=== added file 'loggerhead/tests/test_model.py'
--- loggerhead/tests/test_model.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_model.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,22 @@
+# If your project uses a database, you can set up database tests
+# similar to what you see below. Be sure to set the db_uri to
+# an appropriate uri for your testing database. sqlite is a good
+# choice for testing, because you can use an in-memory database
+# which is very fast.
+
+from turbogears import testutil, database
+# from loggerhead.model import YourDataClass, User
+
+# database.set_db_uri("sqlite:///:memory:")
+
+# class TestUser(testutil.DBTest):
+#     def get_model(self):
+#         return User
+#     def test_creation(self):
+#         "Object creation should set the name"
+#         obj = User(user_name = "creosote",
+#                       email_address = "spam@python.not",
+#                       display_name = "Mr Creosote",
+#                       password = "Wafer-thin Mint")
+#         assert obj.display_name == "Mr Creosote"
+

=== removed file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2007-06-26 19:23:08 +0000
+++ loggerhead/tests/test_simple.py	1970-01-01 00:00:00 +0000
@@ -1,147 +0,0 @@
-from configobj import ConfigObj
-import cgi
-import unittest
-import os
-import tempfile
-import shutil
-import logging
-
-import cherrypy
-from turbogears import testutil
-
-import bzrlib
-
-from loggerhead.controllers import Root
-
-def test_simple():
-    config = ConfigObj()
-    r = Root(config)
-    cherrypy.root = r
-    testutil.create_request('/')
-    assert 'loggerhead branches' in cherrypy.response.body[0]
-
-
-class BasicTests(object):
-
-
-    # there are so i can run it with py.test and take advantage of the
-    # error reporting...
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
-
-    def setUp(self):
-        #logging.basicConfig(level=logging.DEBUG)
-        self.bzrbranch = None
-        self.old_bzrhome = None
-
-    def createBranch(self):
-        self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
-        self.bzrbranch = tempfile.mkdtemp()
-        self.branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
-            self.bzrbranch, force_new_tree=True)
-        self.tree = self.branch.bzrdir.open_workingtree()
-
-    config_template = """
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-    """
-
-    def setUpLoggerhead(self):
-        ini = self.config_template%dict(branch=self.bzrbranch)
-
-        config = ConfigObj(ini.splitlines())
-        cherrypy.root = Root(config)
-
-    def tearDown(self):
-        if self.bzrbranch is not None:
-            shutil.rmtree(self.bzrbranch)
-        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
-
-class TestWithSimpleTree(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-
-        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        self.filecontents = ('some\nmultiline\ndata\n'
-                             'with<htmlspecialchars\n')
-        try:
-            f.write(self.filecontents)
-        finally:
-            f.close()
-        self.tree.add('myfilename')
-        self.fileid = self.tree.path2id('myfilename')
-        self.msg = 'a very exciting commit message <'
-        self.revid = self.tree.commit(message=self.msg)
-
-        self.setUpLoggerhead()
-
-    def test_index(self):
-        testutil.create_request('/')
-        link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0]
-
-    def test_changes(self):
-        testutil.create_request('/project/branch/changes')
-        assert cgi.escape(self.msg) in cherrypy.response.body[0]
-
-    def test_changes_search(self):
-        testutil.create_request('/project/branch/changes?q=foo')
-        assert 'Sorry, no results found for your search.' in cherrypy.response.body[0]
-
-    def test_annotate(self):
-        testutil.create_request('/project/branch/annotate?'
-                                + 'file_id='+self.fileid)
-        for line in self.filecontents.splitlines():
-            assert cgi.escape(line) in cherrypy.response.body[0]
-
-    def test_inventory(self):
-        testutil.create_request('/project/branch/files')
-        assert 'myfilename' in cherrypy.response.body[0]
-
-    def test_revision(self):
-        testutil.create_request('/project/branch/revision/' + self.revid)
-        assert 'myfilename' in cherrypy.response.body[0]
-
-class TestWithSimpleTreeAndCache(TestWithSimpleTree):
-    config_template = """
-    testing = True
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-            cachepath = '%(branch)s/cache'
-    """
-
-class TestEmptyBranch(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.setUpLoggerhead()
-
-    def test_index(self):
-        testutil.create_request('/')
-        link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0]
-
-    def test_changes(self):
-        testutil.create_request('/project/branch/changes')
-        assert 'No revisions!' in cherrypy.response.body[0]
-
-class TestEmptyBranchWithCache(TestEmptyBranch):
-    config_template = """
-    testing = True
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-            cachepath = '%(branch)s/cache'
-    """
-

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-06-25 06:44:52 +0000
+++ loggerhead/util.py	2007-01-21 00:05:52 +0000
@@ -26,7 +26,6 @@
 import struct
 import sys
 import threading
-import time
 import traceback
 
 import turbogears
@@ -181,7 +180,6 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
-# FIXME: get rid of this method; use fixed_width() and avoid XML().
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
@@ -189,31 +187,11 @@
     in displaying monospace text.
     """
     s = cgi.escape(s.expandtabs())
+#    s = _BADCHARS_RE.sub(lambda x: '&#%d;' % (ord(x.group(0)),), s)
     s = s.replace(' ', '&nbsp;')
     return s
 
 
-
-NONBREAKING_SPACE = u'\N{NO-BREAK SPACE}'
-
-def fixed_width(s):
-    """
-    expand tabs and turn spaces into "non-breaking spaces", so browsers won't
-    chop up the string.
-    """
-    if not isinstance(s, unicode):
-        # this kinda sucks.  file contents are just binary data, and no
-        # encoding metadata is stored, so we need to guess.  this is probably
-        # okay for most code, but for people using things like KOI-8, this
-        # will display gibberish.  we have no way of detecting the correct
-        # encoding to use.
-        try:
-            s = s.decode('utf-8')
-        except UnicodeDecodeError:
-            s = s.decode('iso-8859-15')
-    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
-
-
 def fake_permissions(kind, executable):
     # fake up unix-style permissions given only a "kind" and executable bit
     if kind == 'directory':
@@ -293,14 +271,13 @@
     return out
     
 
-def fill_in_navigation(navigation):
+def fill_in_navigation(history, navigation):
     """
     given a navigation block (used by the template for the page header), fill
     in useful calculated values.
     """
-    if navigation.revid in navigation.revid_list: # XXX is this always true?
-        navigation.position = navigation.revid_list.index(navigation.revid)
-    else:
+    navigation.position = history.get_revid_sequence(navigation.revid_list, navigation.revid)
+    if navigation.position is None:
         navigation.position = 0
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
@@ -376,25 +353,6 @@
     return _f
 
 
-@decorator
-def lsprof(f):
-    def _f(*a, **kw):
-        from loggerhead.lsprof import profile
-        import cPickle
-        z = time.time()
-        ret, stats = profile(f, *a, **kw)
-        log.debug('Finished profiled %s in %d msec.' % (f.__name__, int((time.time() - z) * 1000)))
-        stats.sort()
-        stats.freeze()
-        now = time.time()
-        msec = int(now * 1000) % 1000
-        timestr = time.strftime('%Y%m%d%H%M%S', time.localtime(now)) + ('%03d' % msec)
-        filename = f.__name__ + '-' + timestr + '.lsprof'
-        cPickle.dump(stats, open(filename, 'w'), 2)
-        return ret
-    return _f
-
-
 # just thinking out loud here...
 #
 # so, when browsing around, there are 5 pieces of context, most optional:

=== modified file 'setup.py'
--- setup.py	2007-03-26 06:09:27 +0000
+++ setup.py	2006-12-23 19:29:05 +0000
@@ -18,15 +18,14 @@
     
     install_requires = [
         "TurboGears >= 1.0b1",
-# for some reason, distutils can't find bzr.
-#        "bzr >= 0.13",
+        "bzr >= 0.13",
     ],
-    scripts = ["start-loggerhead.py", "stop-loggerhead.py"],
+    scripts = ["start-loggerhead.py"],
     zip_safe=False,
     packages=find_packages(),
     package_data = find_package_data(where='loggerhead',
                                      package='loggerhead'),
-#    data_files = find_package_data(where='loggerhead', package='loggerhead'),
+    data_files = find_package_data(where='loggerhead', package='loggerhead'),
     keywords = [
         'turbogears.app',
     ],

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2007-06-19 00:09:43 +0000
+++ start-loggerhead.py	2007-01-16 03:53:02 +0000
@@ -5,28 +5,15 @@
 
 import logging
 import os
-import sys
-from optparse import OptionParser
 
 import turbogears
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release
-
-
-def make_handler(config, filename):
-    roll = config.get('log.roll', 'never')
-    if roll == 'daily':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
-    elif roll == 'weekly':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
-    else:
-        h = logging.FileHandler(filename)
-    return h
-
-        
-def setup_logging(home, config, foreground):
+import sys
+
+
+def setup_logging(home, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
     log_folder = os.path.join(home, 'logs')
@@ -35,7 +22,7 @@
     
     f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
+    debug_log = logging.FileHandler(os.path.join(log_folder, 'debug.log'))
     debug_log.setLevel(logging.DEBUG)
     debug_log.setFormatter(f)
     if foreground:
@@ -44,7 +31,7 @@
         stdout_log.setFormatter(f)
     f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
+    access_log = logging.FileHandler(os.path.join(log_folder, 'access.log'))
     access_log.setLevel(logging.INFO)
     access_log.setFormatter(f)
     
@@ -57,73 +44,59 @@
     
 
 
-def main():
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
-    parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
-                      help="run in the foreground; don't daemonize")
-    parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
-                      help="only start if not already running (useful for cron jobs)")
-    options, args = parser.parse_args()
-    if len(args) > 0:
-        parser.error('No filename arguments are used, only options.')
-        
-        
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-    
-    if options.check:
-        if daemon.is_running(pidfile):
-            sys.exit(0)
-        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
-    
-    # read loggerhead config
-    
-    from configobj import ConfigObj
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
-    extra_path = config.get('bzrpath', None)
-    if extra_path:
-        sys.path.insert(0, extra_path)
-    
-    turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-    
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
-    for key, keytype in potential_overrides:
-        value = config.get(key, None)
-        if value is not None:
-            value = keytype(value)
-            turbogears.config.update({ key: value })
-    
-    if not options.foreground:
-        sys.stderr.write('\n')
-        sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
-        sys.stderr.write('\n')
-    
-        daemon.daemonize(pidfile, home)
-
-    setup_logging(home, config, foreground=options.foreground)
-        
-    log = logging.getLogger('loggerhead')
-    log.info('Starting up...')
-    
-    from loggerhead.controllers import Root
-    
-    Root = Root(config)
-    
-    # re-index every 6 hours
-    
-    index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
-    turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-    
+foreground = False
+if len(sys.argv) > 1:
+    if sys.argv[1] == '-f':
+        foreground = True
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+# read loggerhead config
+
+from configobj import ConfigObj
+config = sys._loggerhead_config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+extra_path = config.get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
+
+turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
+for key, keytype in potential_overrides:
+    value = config.get(key, None)
+    if value is not None:
+        value = keytype(value)
+        turbogears.config.update({ key: value })
+
+if not foreground:
+    sys.stderr.write('\n')
+    sys.stderr.write('Launching loggerhead into the background.\n')
+    sys.stderr.write('PID file: %s\n' % (pidfile,))
+    sys.stderr.write('\n')
+
+    from loggerhead.daemon import daemonize
+    daemonize(pidfile, home)
+
+setup_logging(home, foreground=foreground)
+    
+log = logging.getLogger('loggerhead')
+log.info('Starting up...')
+
+from loggerhead.controllers import Root
+
+# re-index every 6 hours
+
+index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
+turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
+
+try:
+    turbogears.start_server(Root)
+finally:
+    log.info('Shutdown.')
     try:
-        turbogears.start_server(Root)
-    finally:
-        log.info('Shutdown.')
-        try:
-            os.remove(pidfile)
-        except OSError:
-            pass
-
-
-if __name__ == '__main__':
-    main()
+        os.remove(pidfile)
+    except OSError:
+        pass
+
+

=== removed directory 'turbozpt'
=== removed file 'turbozpt-README.txt'
--- turbozpt-README.txt	2007-06-29 10:47:51 +0000
+++ turbozpt-README.txt	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-TurboZpt
-========
-
-This package provides a TurboGears template engine plugin, allowing you
-to easily use Zope Page Templates with TurboGears.
-
-Zope Page Templates are assumed to have a "pt" extension.
-
-For information on using a TurboGears template plugin, go here:
-
-http://www.turbogears.org/docs/plugins/template.html
-
-At this moment TurboZpt does not do everything KID does. (but neither
-does TurboCheetah as far as i'm awhere)
-
-It's far from final and hopefully see lots of intresting updates in the
-feature. Hopefully as part of the standard set of TurboGears Plugins. :)

=== removed file 'turbozpt-setup.py'
--- turbozpt-setup.py	2007-06-29 10:47:51 +0000
+++ turbozpt-setup.py	1970-01-01 00:00:00 +0000
@@ -1,31 +0,0 @@
-from setuptools import setup, find_packages
-from turbogears.finddata import find_package_data
-
-setup(
-    name="TurboZpt",
-    version="0.1.4",
-    description="TurboGears plugin to support use of Zope Page Templates",
-    author="Bas van Oostveen",
-    author_email="v.oostveen@gmail.com",
-    url="http://ido.nl.eu.org/turbozpt/",
-    download_url="http://ido.nl.eu.org/turbozpt/TurboZpt-0.1.2.tar.gz",
-    license="MIT",
-#    install_requires = ["TurboGears >= 0.9a0dev", "ZopePageTemplates"],
-    install_requires = ["TurboGears >= 0.9a0dev"],
-    zip_safe=False,
-    packages=find_packages(),
-    classifiers = [
-        'Development Status :: 3 - Alpha',
-        #'Environment :: TurboGears',
-        'Operating System :: OS Independent',
-        'Programming Language :: Python',
-        'License :: OSI Approved :: MIT License',
-        'Topic :: Software Development :: Libraries :: Python Modules'
-    ],
-    entry_points="""
-    [python.templating.engines]
-    zpt = turbozpt.zptsupport:TurboZpt
-    """,
-    test_suite = 'nose.collector',
-    )
-    

=== removed file 'turbozpt/__init__.py'
--- turbozpt/__init__.py	2007-06-29 10:47:51 +0000
+++ turbozpt/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,9 +0,0 @@
-from turbozpt import zptsupport
-
-TurboZpt = zptsupport.TurboZpt
-
-__all__ = ["TurboZpt"]
-
-from turbogears.view import engines, stdvars
-
-engines['zpt'] = TurboZpt(stdvars, {})

=== removed file 'turbozpt/template.py'
--- turbozpt/template.py	2007-07-05 09:10:39 +0000
+++ turbozpt/template.py	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-"""
-By VladDrac@irc.freenode.net/#turbogears
-+ Some small modifications
-"""
-
-from zope.pagetemplate import pagetemplatefile
-import os.path
-import sys
-
-class Here(object):
-    def __init__(self, base, options):
-        self.base = base
-        self.options = options
-
-    def __getitem__(self, name):
-        tpl = PageTemplate(os.path.join(self.base, name))
-        tpl.add_context(self.options)
-        return tpl
-
-class PageTemplate(pagetemplatefile.PageTemplateFile):
-    def __init__(self, name):
-    	base = os.path.dirname(sys._getframe(1).f_globals["__file__"])
-	self.extra_context = {}
-        self.name = name
-        self.fullpath = os.path.join(base, self.name)
-        self.base = os.path.dirname(self.fullpath)
-        pagetemplatefile.PageTemplateFile.__init__(self, self.fullpath)
-    
-    def render(self, extra_dict=None):
-	if extra_dict:
-    	    context = self.pt_getContext()
-	    context.update(extra_dict)
-	return self.pt_render(context)
-    
-    def add_context(self, d):
-	self.extra_context.update(d)
-	
-    def pt_getContext(self, args=(), options={}, **ignored):
-        rval = pagetemplatefile.PageTemplateFile.pt_getContext(self, args, options, **ignored)
-	rval.update(options)
-	rval.update(self.extra_context)
-        rval.update({'here':Here(self.base, options), 'template':self})
-        return rval

=== removed directory 'turbozpt/tests'
=== removed file 'turbozpt/tests/__init__.py'
=== removed file 'turbozpt/tests/simple.pt'
--- turbozpt/tests/simple.pt	2007-06-29 10:47:51 +0000
+++ turbozpt/tests/simple.pt	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-<html>
-<head>
-<title tal:content="title">simple test page title</title>
-</head>
-<body>
-<div>Hello, <span tal:replace="name">name</span></div>
-</body>
-</html>

=== removed file 'turbozpt/tests/test_zpt.py'
--- turbozpt/tests/test_zpt.py	2007-06-29 10:47:51 +0000
+++ turbozpt/tests/test_zpt.py	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-from turbozpt import TurboZpt
-from turbogears import controllers
-from turbogears import testutil
-import turbogears
-import cherrypy
-
-RENDERED="<html>\n<head>\n<title>%s</title>\n</head>\n<body>\n<div>Hello, %s</div>\n</body>\n</html>\n"
-
-def test_template_lookup():
-    tc = TurboZpt()
-    template = tc.load_template("turbozpt.tests.simple")
-    assert template
-    TITLE="test"
-    NAME="World"
-    info = dict(title=TITLE, name=NAME)
-    t = template(**info)
-    assert str(t).startswith(RENDERED % (TITLE, NAME))
-
-class TestRoot(controllers.Root):
-    def index(self, name, title="test"):
-        return dict(name=name, title=title)
-    index = turbogears.expose(html="zpt:turbozpt.tests.simple")(index)
-
-def test_real_life_situation():
-    cherrypy.root = TestRoot()
-    TITLE="test dave"
-    NAME="Dave"
-    testutil.createRequest("/?name=%s" % NAME)
-    print cherrypy.response.body
-    assert cherrypy.response.body[0].startswith(RENDERED % ("test", NAME))

=== removed file 'turbozpt/zptsupport.py'
--- turbozpt/zptsupport.py	2007-07-04 15:55:56 +0000
+++ turbozpt/zptsupport.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-"TurboGears support for Zope Page Templates"
-
-import sys, os
-
-from template import PageTemplate
-import pkg_resources
-
-import logging
-log = logging.getLogger("turbogears.zptsupport")
-
-def _recompile_template(package, basename, tfile, classname):
-    log.debug("Recompiling template for %s" % classname)
-    mod = PageTemplate(tfile)
-    mtime = os.stat(tfile).st_mtime
-    mod.__mtime__ = mtime
-    return mod
-
-class TurboZpt:
-    extension = "pt"
-    
-    def __init__(self, extra_vars_func=None, options={}):
-	self.options = options
-	self.get_extra_vars = extra_vars_func
-        self.compiledTemplates = {}
-    
-    def load_template(self, classname, loadingSite=False):
-        """Searches for a template along the Python path.
-
-        Template files must end in ".pt" and be in legitimate packages.
-        U can set "zpt.cache_templates" option to cache a loaded template
-	class and only check for updates. Templates are automatically
-	checked for changes and reloaded as neccessary.
-        """
-        ct = self.compiledTemplates
-
-        divider = classname.rfind(".")
-        if divider > -1:
-            package = classname[0:divider]
-            basename = classname[divider+1:]
-        else:
-            raise ValueError, "All templates must be in a package"
-
-        cache_templates = self.options.get("zpt.cache_templates", True)
-        tfile = pkg_resources.resource_filename(package, 
-                                                "%s.%s" % 
-                                                (basename,
-                                                self.extension))
-						
-        if cache_templates:
-            if ct.has_key(classname):
-                mtime = os.stat(tfile).st_mtime
-		mod = ct[classname]
-                if mod.__mtime__ != mtime:
-		    # Recompile template
-		    mod = _recompile_template(package, basename, tfile, classname)
-                    ct[classname] = mod
-                #else:
-		    # use template from cache    
-		    # pass 
-            else:
-		# First time compile template
-		mod = PageTemplate(tfile)
-                mod.__mtime__ = os.stat(tfile).st_mtime
-		ct[classname] = mod
-        else:
-	    mod = PageTemplate(tfile)
-
-        return mod
-
-    def render(self, info, format="html", fragment=False, template=None):
-	"""Renders data in the desired format.
-	
-	@param info: the data / context itself
-	@type info: dict
-	@para format: "html"
-	@type format: "string"
-	@para template: name of the template to use
-	@type template: string
-	"""
-	#if isinstance(template, type):
-	#    tclass = template
-	#else:
-	
-	tinstance = self.load_template(template)
-	log.debug("Applying template %s" % (tinstance.filename))
-	data = dict()
-	if self.get_extra_vars:
-	    data.update(self.get_extra_vars())
-	data.update(info)
-        print '!!!!', data.keys()
-        return tinstance(**data)
-
-    def transform(self, info, template):
-	"Render the output to Elements"
-	pass

